/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 30 "parser.yy"


#define yyerror Lily_parser::parser_error

/* We use custom location type: Input objects */
#define YYLTYPE Input
#define YYSTYPE SCM
#define YYLLOC_DEFAULT(Current,Rhs,N) \
	((Current).set_location ((Rhs)[1], (Rhs)[N]))

#define YYPRINT(file, type, value)					\
	do {								\
		if (scm_is_eq (value, SCM_UNSPECIFIED))			\
			break;						\
		SCM s = scm_call_2 (ly_lily_module_constant ("value->lily-string"), \
				    value,				\
				    parser->self_scm ());		\
		char *p = scm_to_locale_string (s);			\
		fputs (p, file);					\
		free (p);						\
	} while (0)

/* Line 371 of yacc.c  */
#line 105 "parser.yy"
 // -*-Fundamental-*-

/*
FIXME:

   * The rules for who is protecting what are very shady.  Uniformise
     this.

   * There are too many lexical modes?
*/

#include "config.hh"

#include <cctype>
#include <cstdlib>
#include <cstdio>
using namespace std;

#include "book.hh"
#include "context-def.hh"
#include "context-mod.hh"
#include "dimensions.hh"
#include "file-path.hh"
#include "input.hh"
#include "international.hh"
#include "lily-guile.hh"
#include "lily-lexer.hh"
#include "lily-parser.hh"
#include "main.hh"
#include "misc.hh"
#include "music.hh"
#include "output-def.hh"
#include "paper-book.hh"
#include "scm-hash.hh"
#include "score.hh"
#include "text-interface.hh"
#include "warn.hh"

void
Lily_parser::parser_error (Input const *i, Lily_parser *parser, SCM *, const string &s)
{
	parser->parser_error (*i, s);
}

#define MYBACKUP(Token, Value, Location)				\
do									\
	if (yychar == YYEMPTY)						\
	{								\
		if (Token)						\
			parser->lexer_->push_extra_token (Token, Value); \
		parser->lexer_->push_extra_token (BACKUP);		\
	} else {							\
		parser->parser_error					\
			(Location, _("Too much lookahead"));		\
	}								\
while (0)


#define MYREPARSE(Location, Pred, Token, Value)				\
do									\
	if (yychar == YYEMPTY)						\
	{								\
		parser->lexer_->push_extra_token (Token, Value);	\
		parser->lexer_->push_extra_token (REPARSE,		\
						  Pred);		\
	} else {							\
		parser->parser_error					\
			(Location, _("Too much lookahead"));		\
	}								\
while (0)

/* Line 371 of yacc.c  */
#line 179 "parser.yy"


#define MY_MAKE_MUSIC(x, spot) \
	make_music_with_input (ly_symbol2scm (x), \
			       parser->lexer_->override_input (spot))

/* ES TODO:
- Don't use lily module, create a new module instead.
- delay application of the function
*/
#define LOWLEVEL_MAKE_SYNTAX(proc, args)	\
  scm_apply_0 (proc, args)
/* Syntactic Sugar. */
#define MAKE_SYNTAX(name, location, ...)				\
	LOWLEVEL_MAKE_SYNTAX (ly_lily_module_constant (name), scm_list_n (parser->self_scm (), make_input (parser->lexer_->override_input (location)), ##__VA_ARGS__, SCM_UNDEFINED))
#define START_MAKE_SYNTAX(name, ...)					\
	scm_list_n (ly_lily_module_constant (name) , ##__VA_ARGS__, SCM_UNDEFINED)
#define FINISH_MAKE_SYNTAX(start, location, ...)			\
	LOWLEVEL_MAKE_SYNTAX (scm_car (start), scm_cons2 (parser->self_scm (), make_input (parser->lexer_->override_input (location)), scm_append_x (scm_list_2 (scm_cdr (start), scm_list_n (__VA_ARGS__, SCM_UNDEFINED)))))

SCM get_next_unique_context_id ();
SCM get_next_unique_lyrics_context_id ();

#undef _
#if !HAVE_GETTEXT
#define _(x) x
#else
#include <libintl.h>
#define _(x) gettext (x)
#endif


static Music *make_music_with_input (SCM name, Input where);
SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp = SCM_UNDEFINED);
SCM make_music_from_simple (Lily_parser *parser, Input loc, SCM pitch);
SCM loc_on_music (Input loc, SCM arg);
SCM make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list);
SCM make_chord_step (SCM step, Rational alter);
SCM make_simple_markup (SCM a);
SCM make_duration (SCM t, int dots = 0);
bool is_regular_identifier (SCM id, bool multiple=false);
SCM try_string_variants (SCM pred, SCM str);
int yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser);


/* Line 371 of yacc.c  */
#line 212 "./out/parser.cc"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.hh".  */
#ifndef YY_YY_OUT_PARSER_HH_INCLUDED
# define YY_YY_OUT_PARSER_HH_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END_OF_FILE = 0,
     PREC_BOT = 258,
     REPEAT_IDENTIFIER = 259,
     REPEAT = 260,
     ALTERNATIVE = 261,
     COMPOSITE = 262,
     ADDLYRICS = 263,
     DURATION_IDENTIFIER = 264,
     EXTENDER = 265,
     HYPHEN = 266,
     EVENT_FUNCTION = 267,
     EVENT_IDENTIFIER = 268,
     E_UNSIGNED = 269,
     REAL = 270,
     UNSIGNED = 271,
     NUMBER_IDENTIFIER = 272,
     PREC_TOP = 273,
     ACCEPTS = 274,
     ALIAS = 275,
     BOOK = 276,
     BOOKPART = 277,
     CHANGE = 278,
     CHORDMODE = 279,
     CHORDS = 280,
     CONSISTS = 281,
     CONTEXT = 282,
     DEFAULT = 283,
     DEFAULTCHILD = 284,
     DENIES = 285,
     DESCRIPTION = 286,
     DRUMMODE = 287,
     DRUMS = 288,
     FIGUREMODE = 289,
     FIGURES = 290,
     HEADER = 291,
     INVALID = 292,
     LAYOUT = 293,
     LYRICMODE = 294,
     LYRICS = 295,
     LYRICSTO = 296,
     MARKUP = 297,
     MARKUPLIST = 298,
     MIDI = 299,
     NAME = 300,
     NOTEMODE = 301,
     OVERRIDE = 302,
     PAPER = 303,
     REMOVE = 304,
     REST = 305,
     REVERT = 306,
     SCORE = 307,
     SEQUENTIAL = 308,
     SET = 309,
     SIMULTANEOUS = 310,
     TEMPO = 311,
     TYPE = 312,
     UNSET = 313,
     WITH = 314,
     NEWCONTEXT = 315,
     CHORD_BASS = 316,
     CHORD_CARET = 317,
     CHORD_COLON = 318,
     CHORD_MINUS = 319,
     CHORD_SLASH = 320,
     ANGLE_OPEN = 321,
     ANGLE_CLOSE = 322,
     DOUBLE_ANGLE_OPEN = 323,
     DOUBLE_ANGLE_CLOSE = 324,
     E_BACKSLASH = 325,
     E_EXCLAMATION = 326,
     E_PLUS = 327,
     FIGURE_CLOSE = 328,
     FIGURE_OPEN = 329,
     FIGURE_SPACE = 330,
     MULTI_MEASURE_REST = 331,
     EXPECT_MARKUP = 332,
     EXPECT_SCM = 333,
     BACKUP = 334,
     REPARSE = 335,
     EXPECT_MARKUP_LIST = 336,
     EXPECT_OPTIONAL = 337,
     EXPECT_NO_MORE_ARGS = 338,
     EMBEDDED_LILY = 339,
     BOOK_IDENTIFIER = 340,
     CHORD_BODY_IDENTIFIER = 341,
     CHORD_MODIFIER = 342,
     CHORD_REPETITION = 343,
     CONTEXT_DEF_IDENTIFIER = 344,
     CONTEXT_MOD_IDENTIFIER = 345,
     DRUM_PITCH = 346,
     PITCH_IDENTIFIER = 347,
     PITCH_ARG = 348,
     FRACTION = 349,
     LYRIC_ELEMENT = 350,
     MARKUP_FUNCTION = 351,
     MARKUP_LIST_FUNCTION = 352,
     MARKUP_IDENTIFIER = 353,
     MARKUPLIST_IDENTIFIER = 354,
     MUSIC_FUNCTION = 355,
     MUSIC_IDENTIFIER = 356,
     NOTENAME_PITCH = 357,
     OUTPUT_DEF_IDENTIFIER = 358,
     RESTNAME = 359,
     SCM_ARG = 360,
     SCM_FUNCTION = 361,
     SCM_IDENTIFIER = 362,
     SCM_TOKEN = 363,
     STRING = 364,
     SYMBOL_LIST = 365,
     TONICNAME_PITCH = 366,
     UNARY_MINUS = 367
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (Lily_parser *parser, SCM *retval);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_OUT_PARSER_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 403 "./out/parser.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3061

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  130
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  196
/* YYNRULES -- Number of rules.  */
#define YYNRULES  541
/* YYNRULES -- Number of states.  */
#define YYNSTATES  734

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   367

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   124,     2,     2,     2,     2,     2,   122,
       2,     2,   125,   116,   123,   115,   121,   127,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     9,     2,
       2,   120,     2,   129,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   128,     2,   126,    10,    11,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   118,     2,   119,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   117
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     6,    10,    11,    14,    17,    20,
      23,    24,    27,    29,    31,    33,    35,    37,    39,    41,
      43,    45,    47,    49,    51,    53,    55,    57,    59,    61,
      63,    65,    67,    69,    71,    73,    75,    77,    79,    81,
      83,    85,    88,    89,    91,    95,    97,   100,   101,   104,
     107,   112,   114,   118,   123,   129,   131,   133,   135,   137,
     139,   141,   144,   146,   148,   150,   152,   154,   156,   161,
     163,   164,   167,   169,   170,   172,   175,   178,   181,   186,
     187,   189,   192,   195,   198,   201,   204,   207,   210,   213,
     214,   218,   221,   226,   227,   229,   232,   235,   238,   241,
     244,   247,   250,   251,   255,   258,   263,   264,   265,   269,
     272,   275,   277,   278,   282,   285,   288,   290,   293,   295,
     297,   299,   301,   303,   305,   308,   312,   315,   318,   319,
     323,   326,   331,   337,   340,   341,   344,   347,   351,   353,
     355,   357,   359,   363,   365,   367,   369,   371,   373,   378,
     381,   388,   393,   396,   398,   401,   405,   407,   409,   411,
     412,   418,   421,   423,   426,   428,   430,   431,   433,   434,
     437,   440,   443,   445,   447,   449,   452,   454,   456,   458,
     460,   462,   464,   469,   475,   481,   487,   489,   491,   496,
     501,   506,   511,   516,   518,   522,   524,   528,   530,   532,
     534,   536,   538,   543,   548,   552,   556,   560,   564,   568,
     573,   578,   583,   588,   593,   595,   600,   607,   612,   617,
     622,   627,   632,   637,   643,   649,   655,   660,   665,   670,
     675,   680,   685,   689,   693,   697,   701,   705,   707,   712,
     714,   718,   720,   724,   728,   732,   737,   741,   745,   749,
     753,   757,   761,   765,   769,   773,   777,   782,   787,   789,
     794,   796,   800,   804,   809,   813,   817,   821,   825,   827,
     832,   835,   837,   841,   843,   845,   847,   849,   851,   854,
     857,   858,   861,   863,   865,   867,   870,   875,   880,   883,
     887,   889,   891,   893,   895,   897,   899,   901,   903,   905,
     906,   910,   911,   916,   919,   920,   925,   930,   932,   935,
     939,   942,   947,   950,   954,   956,   958,   964,   969,   971,
     973,   975,   977,   979,   981,   983,   985,   987,   989,   992,
     995,   997,   999,  1002,  1004,  1009,  1013,  1018,  1021,  1023,
    1025,  1027,  1029,  1031,  1033,  1035,  1037,  1039,  1041,  1043,
    1046,  1048,  1050,  1053,  1056,  1060,  1064,  1066,  1068,  1072,
    1076,  1078,  1079,  1082,  1088,  1091,  1093,  1095,  1097,  1099,
    1102,  1105,  1107,  1109,  1110,  1113,  1115,  1118,  1120,  1122,
    1125,  1128,  1131,  1134,  1136,  1139,  1141,  1143,  1145,  1147,
    1149,  1151,  1153,  1154,  1157,  1158,  1160,  1162,  1164,  1167,
    1169,  1172,  1175,  1178,  1180,  1183,  1186,  1188,  1190,  1192,
    1194,  1196,  1198,  1200,  1202,  1204,  1206,  1208,  1210,  1212,
    1214,  1216,  1217,  1219,  1221,  1224,  1227,  1229,  1233,  1237,
    1238,  1241,  1243,  1246,  1248,  1250,  1252,  1254,  1256,  1258,
    1260,  1262,  1264,  1267,  1270,  1273,  1275,  1277,  1279,  1281,
    1283,  1286,  1287,  1290,  1294,  1295,  1297,  1304,  1307,  1310,
    1312,  1315,  1317,  1319,  1321,  1325,  1328,  1333,  1334,  1337,
    1339,  1341,  1344,  1347,  1349,  1351,  1353,  1355,  1359,  1361,
    1364,  1367,  1369,  1373,  1377,  1381,  1383,  1385,  1389,  1393,
    1396,  1398,  1400,  1403,  1405,  1407,  1409,  1411,  1414,  1416,
    1418,  1420,  1422,  1424,  1425,  1428,  1429,  1432,  1433,  1437,
    1438,  1442,  1444,  1447,  1449,  1450,  1454,  1456,  1458,  1460,
    1462,  1465,  1468,  1472,  1473,  1476,  1479,  1482,  1486,  1490,
    1492,  1494,  1498,  1502,  1504,  1507,  1509,  1510,  1516,  1519,
    1522,  1525
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     131,     0,    -1,   133,    -1,    -1,    87,   132,   142,    -1,
      -1,   133,   134,    -1,   133,   146,    -1,   133,     1,    -1,
     133,    40,    -1,    -1,   135,   144,    -1,   153,    -1,   156,
      -1,    88,    -1,   159,    -1,   188,    -1,   308,    -1,   306,
      -1,   111,    -1,   137,    -1,   165,    -1,   111,    -1,   110,
      -1,   110,    -1,   141,    -1,   108,    -1,   111,    -1,    97,
      -1,   306,    -1,   183,    -1,   159,    -1,   148,    -1,   153,
      -1,   156,    -1,   165,    -1,   136,    -1,   141,    -1,   138,
      -1,   141,    -1,   178,    -1,   109,   201,    -1,    -1,   147,
      -1,   175,   175,   172,    -1,     1,    -1,    40,   142,    -1,
      -1,   143,   146,    -1,   143,   139,    -1,    39,   118,   143,
     119,    -1,   112,    -1,   145,   120,   147,    -1,   145,   225,
     120,   147,    -1,   145,   121,   225,   120,   147,    -1,   159,
      -1,   153,    -1,   156,    -1,   165,    -1,   148,    -1,   178,
      -1,   253,   252,    -1,   296,    -1,    97,    -1,   238,    -1,
     139,    -1,   306,    -1,   183,    -1,    30,   118,   152,   119,
      -1,   139,    -1,    -1,   150,   188,    -1,   149,    -1,    -1,
      92,    -1,   152,   231,    -1,   152,   183,    -1,   152,   151,
      -1,    24,   118,   154,   119,    -1,    -1,    88,    -1,   154,
     164,    -1,   154,   156,    -1,   154,   159,    -1,   154,   188,
      -1,   154,   308,    -1,   154,   306,    -1,   154,   111,    -1,
     154,   137,    -1,    -1,   154,   155,   144,    -1,   154,     1,
      -1,    25,   118,   157,   119,    -1,    -1,    88,    -1,   157,
     164,    -1,   157,   159,    -1,   157,   188,    -1,   157,   308,
      -1,   157,   306,    -1,   157,   111,    -1,   157,   137,    -1,
      -1,   157,   158,   144,    -1,   157,     1,    -1,    55,   118,
     162,   119,    -1,    -1,    -1,   160,   161,   144,    -1,   160,
     165,    -1,   160,   174,    -1,   137,    -1,    -1,   162,   163,
     144,    -1,   162,   165,    -1,   162,     1,    -1,   165,    -1,
     169,   119,    -1,    51,    -1,    47,    -1,    41,    -1,   166,
      -1,   177,    -1,   148,    -1,   167,   118,    -1,   167,   118,
     106,    -1,   169,   146,    -1,   169,   139,    -1,    -1,   169,
     170,   168,    -1,   169,     1,    -1,    59,   273,   120,   295,
      -1,    59,   241,   273,   120,   295,    -1,    59,   241,    -1,
      -1,   172,   175,    -1,   172,     1,    -1,   118,   172,   119,
      -1,   177,    -1,   288,    -1,   174,    -1,   176,    -1,   176,
      82,   288,    -1,   139,    -1,   182,    -1,   188,    -1,   182,
      -1,   188,    -1,     5,   239,   303,   174,    -1,     4,   174,
      -1,     5,   239,   303,   174,     6,   173,    -1,     4,   174,
       6,   173,    -1,    56,   173,    -1,   173,    -1,    58,   173,
      -1,    71,   172,    72,    -1,   242,    -1,   237,    -1,   224,
      -1,    -1,    62,   184,   118,   187,   119,    -1,    62,    93,
      -1,    93,    -1,    62,   185,    -1,   209,    -1,   104,    -1,
      -1,   183,    -1,    -1,   187,   231,    -1,   187,    93,    -1,
     187,   151,    -1,   214,    -1,   190,    -1,   190,    -1,   215,
     189,    -1,   248,    -1,   216,    -1,   104,    -1,   191,    -1,
     181,    -1,   180,    -1,    85,    81,   198,   253,    -1,    85,
      81,   198,   115,    19,    -1,    85,    81,   198,   115,    18,
      -1,    85,    81,   198,   115,    20,    -1,   192,    -1,   206,
      -1,    85,    81,   198,   210,    -1,    85,    81,   198,   302,
      -1,    85,    81,   198,   110,    -1,    85,    81,   198,   112,
      -1,    85,    81,   198,   308,    -1,   113,    -1,   113,   121,
     195,    -1,   196,    -1,   195,   121,   196,    -1,   197,    -1,
     112,    -1,   136,    -1,   192,    -1,   203,    -1,    85,    81,
     198,   140,    -1,    85,    81,   198,   299,    -1,   199,    83,
     270,    -1,   199,    83,   299,    -1,   199,    83,   108,    -1,
     199,    83,   288,    -1,   199,    83,   194,    -1,    85,    81,
     198,   110,    -1,    85,    81,   198,   112,    -1,    85,    81,
     198,   308,    -1,    85,    81,   198,    19,    -1,    85,    81,
     198,    12,    -1,   203,    -1,    85,    81,   200,   210,    -1,
      85,    81,   200,     5,   239,   303,    -1,    85,    81,   200,
     244,    -1,    85,    81,   200,   253,    -1,    85,    81,   200,
     308,    -1,    85,    81,   200,    19,    -1,    85,    81,   200,
      18,    -1,    85,    81,   200,    20,    -1,    85,    81,   200,
     115,    19,    -1,    85,    81,   200,   115,    18,    -1,    85,
      81,   200,   115,    20,    -1,    85,    81,   200,    95,    -1,
      85,    81,   200,   105,    -1,    85,    81,   200,   114,    -1,
      85,    81,   200,    12,    -1,    85,    81,   200,   110,    -1,
      85,    81,   200,   112,    -1,   200,    83,   178,    -1,   200,
      83,   265,    -1,   200,    83,   299,    -1,   200,    83,   270,
      -1,   200,    83,   194,    -1,   198,    -1,    85,    81,   202,
      31,    -1,   198,    -1,    85,    81,   202,    -1,    86,    -1,
      81,   207,   140,    -1,    81,   207,   299,    -1,    81,   207,
     253,    -1,    81,   207,   115,    20,    -1,   204,    83,   108,
      -1,   204,    83,   288,    -1,   204,    83,   299,    -1,   204,
      83,   270,    -1,   204,    83,   194,    -1,    81,   207,   110,
      -1,    81,   207,   112,    -1,    81,   207,   308,    -1,    81,
     207,    19,    -1,    81,   207,    12,    -1,    81,   207,   115,
      19,    -1,    81,   207,   115,    18,    -1,   193,    -1,    85,
      81,   202,    31,    -1,    86,    -1,    81,   207,   210,    -1,
      81,   207,   300,    -1,    81,   207,   115,    20,    -1,    81,
     207,   253,    -1,   204,    83,   108,    -1,   204,    83,   300,
      -1,   204,    83,   194,    -1,   200,    -1,    85,    81,   208,
      31,    -1,   208,    82,    -1,   200,    -1,    85,    81,   208,
      -1,   136,    -1,   211,    -1,   138,    -1,   211,    -1,   189,
      -1,   109,   205,    -1,   103,   201,    -1,    -1,   120,   239,
      -1,   212,    -1,   179,    -1,   222,    -1,   215,   174,    -1,
      30,   240,   213,   186,    -1,    63,   240,   213,   186,    -1,
     217,   191,    -1,   218,   186,   191,    -1,    49,    -1,    35,
      -1,    37,    -1,    27,    -1,    42,    -1,    36,    -1,    38,
      -1,    28,    -1,    43,    -1,    -1,     8,   220,   188,    -1,
      -1,   219,     8,   221,   188,    -1,   188,   219,    -1,    -1,
      44,   239,   223,   174,    -1,    26,   240,   120,   239,    -1,
     195,    -1,   195,   225,    -1,   240,   120,   241,    -1,    61,
     240,    -1,    50,   225,   120,   241,    -1,    54,   227,    -1,
     228,    82,   194,    -1,   229,    -1,   196,    -1,   228,    82,
     108,   121,   196,    -1,   228,    82,   108,   196,    -1,    29,
      -1,    52,    -1,    22,    -1,    32,    -1,    33,    -1,    23,
      -1,    60,    -1,    34,    -1,    48,    -1,   226,    -1,   230,
     112,    -1,   230,   139,    -1,   195,    -1,   232,    -1,   232,
     225,    -1,   195,    -1,    50,   233,   120,   241,    -1,    54,
     236,   227,    -1,    57,   234,   120,   241,    -1,    61,   234,
      -1,   196,    -1,   235,    -1,   112,    -1,   308,    -1,   112,
      -1,   136,    -1,   112,    -1,   136,    -1,   140,    -1,   110,
      -1,   301,    -1,   115,   301,    -1,   112,    -1,   308,    -1,
     285,   252,    -1,   286,   252,    -1,    91,   272,   252,    -1,
      79,   272,   252,    -1,   250,    -1,   243,    -1,   244,   272,
     252,    -1,    69,   245,    70,    -1,    89,    -1,    -1,   245,
     246,    -1,   264,   304,   305,   258,   252,    -1,    94,   252,
      -1,   247,    -1,   212,    -1,   104,    -1,   139,    -1,   103,
     205,    -1,    15,   205,    -1,   251,    -1,   171,    -1,    -1,
     252,   254,    -1,   256,    -1,   269,   248,    -1,    14,    -1,
      13,    -1,   269,   257,    -1,   269,   256,    -1,    10,   267,
      -1,    11,   267,    -1,   253,    -1,   115,   267,    -1,    17,
      -1,   255,    -1,    16,    -1,   276,    -1,   249,    -1,   266,
      -1,   268,    -1,    -1,   120,   259,    -1,    -1,   261,    -1,
     260,    -1,   122,    -1,   260,   122,    -1,   123,    -1,   261,
     123,    -1,   105,   259,    -1,   114,   259,    -1,   262,    -1,
      95,   259,    -1,    96,   259,    -1,   308,    -1,   112,    -1,
     209,    -1,    19,    -1,    10,    -1,   116,    -1,   115,    -1,
     124,    -1,    70,    -1,   121,    -1,    11,    -1,    11,    -1,
      10,    -1,   115,    -1,   274,    -1,    -1,   274,    -1,   271,
      -1,    19,   275,    -1,    12,   275,    -1,   273,    -1,   274,
     125,    19,    -1,   274,   125,    97,    -1,    -1,   275,   121,
      -1,     9,    -1,     9,    19,    -1,    19,    -1,   112,    -1,
     308,    -1,   136,    -1,   115,    -1,   116,    -1,   124,    -1,
      78,    -1,   277,    -1,   279,   126,    -1,   279,   278,    -1,
     279,   280,    -1,    75,    -1,    74,    -1,   127,    -1,    73,
      -1,   279,    -1,   128,   279,    -1,    -1,   282,   281,    -1,
      77,   282,    76,    -1,    -1,    53,    -1,   264,   304,   305,
     258,   271,   284,    -1,    94,   272,    -1,   107,   272,    -1,
     289,    -1,   283,   272,    -1,   308,    -1,   112,    -1,    98,
      -1,   287,   272,   252,    -1,   263,   271,    -1,   263,   272,
     291,   290,    -1,    -1,   290,   292,    -1,    66,    -1,    65,
      -1,    68,   263,    -1,    64,   263,    -1,   291,    -1,   293,
      -1,    90,    -1,   294,    -1,   293,   121,   294,    -1,    19,
      -1,    19,   116,    -1,    19,    67,    -1,   303,    -1,   303,
     115,   303,    -1,   296,   116,   297,    -1,   296,   115,   297,
      -1,   297,    -1,   298,    -1,   298,   125,   298,    -1,   298,
     127,   298,    -1,   115,   298,    -1,   301,    -1,   300,    -1,
      18,    20,    -1,    18,    -1,    20,    -1,   299,    -1,    19,
      -1,    19,    20,    -1,    19,    -1,   300,    -1,    19,    -1,
      20,    -1,   139,    -1,    -1,   304,   124,    -1,    -1,   305,
     129,    -1,    -1,    46,   307,   313,    -1,    -1,    45,   309,
     310,    -1,   313,    -1,   322,   323,    -1,   323,    -1,    -1,
     136,   312,    82,    -1,   315,    -1,   314,    -1,   316,    -1,
     318,    -1,   311,   102,    -1,   322,   314,    -1,   118,   317,
     119,    -1,    -1,   317,   325,    -1,   317,   313,    -1,   100,
     320,    -1,    84,   320,   313,    -1,    81,   320,   209,    -1,
      86,    -1,   319,    -1,    80,   320,   325,    -1,    99,    80,
     320,    -1,   321,    -1,   322,   321,    -1,   112,    -1,    -1,
      55,   324,   118,   162,   119,    -1,    99,   319,    -1,   311,
     101,    -1,   322,   323,    -1,   323,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   371,   371,   372,   372,   381,   382,   384,   386,   389,
     396,   396,   401,   405,   409,   416,   420,   424,   428,   432,
     436,   454,   470,   474,   478,   479,   483,   484,   488,   489,
     490,   491,   492,   493,   494,   495,   501,   502,   515,   516,
     517,   521,   529,   536,   537,   545,   549,   557,   558,   561,
     567,   576,   580,   584,   589,   598,   599,   600,   601,   602,
     603,   604,   626,   627,   628,   629,   630,   631,   635,   643,
     645,   645,   657,   674,   677,   680,   684,   691,   703,   715,
     725,   728,   732,   736,   740,   744,   748,   752,   756,   775,
     774,   778,   787,   795,   800,   803,   806,   810,   814,   818,
     822,   826,   845,   844,   851,   859,   867,   871,   870,   880,
     901,   917,   925,   924,   931,   943,   954,   967,   976,   982,
     987,   996,  1008,  1009,  1013,  1017,  1024,  1027,  1031,  1030,
    1047,  1053,  1056,  1059,  1068,  1071,  1075,  1085,  1091,  1092,
    1096,  1103,  1107,  1114,  1136,  1145,  1149,  1150,  1154,  1158,
    1163,  1167,  1175,  1178,  1184,  1187,  1193,  1194,  1195,  1200,
    1199,  1208,  1212,  1216,  1232,  1233,  1237,  1240,  1247,  1250,
    1254,  1259,  1266,  1267,  1272,  1273,  1277,  1281,  1282,  1283,
    1287,  1288,  1352,  1356,  1369,  1375,  1384,  1385,  1386,  1390,
    1394,  1400,  1406,  1413,  1414,  1421,  1422,  1431,  1445,  1446,
    1451,  1452,  1453,  1463,  1467,  1471,  1475,  1479,  1483,  1490,
    1507,  1524,  1537,  1550,  1563,  1564,  1574,  1588,  1599,  1609,
    1618,  1636,  1647,  1657,  1677,  1688,  1698,  1714,  1730,  1746,
    1757,  1772,  1787,  1797,  1802,  1807,  1812,  1819,  1820,  1827,
    1828,  1835,  1838,  1848,  1853,  1858,  1863,  1868,  1873,  1878,
    1883,  1890,  1908,  1926,  1940,  1953,  1958,  1975,  1984,  1985,
    1992,  1995,  2000,  2005,  2011,  2016,  2021,  2026,  2033,  2034,
    2038,  2042,  2043,  2050,  2051,  2055,  2056,  2057,  2061,  2068,
    2076,  2077,  2083,  2084,  2085,  2086,  2093,  2100,  2110,  2121,
    2136,  2142,  2149,  2154,  2162,  2169,  2175,  2180,  2187,  2194,
    2194,  2203,  2203,  2212,  2215,  2215,  2224,  2231,  2234,  2240,
    2243,  2246,  2257,  2286,  2293,  2305,  2306,  2310,  2317,  2318,
    2320,  2321,  2322,  2324,  2325,  2326,  2327,  2331,  2332,  2335,
    2353,  2371,  2379,  2394,  2411,  2422,  2428,  2437,  2463,  2481,
    2490,  2493,  2496,  2499,  2511,  2514,  2531,  2532,  2533,  2541,
    2545,  2546,  2550,  2564,  2579,  2585,  2591,  2592,  2597,  2615,
    2619,  2623,  2624,  2631,  2657,  2667,  2684,  2685,  2686,  2695,
    2702,  2709,  2715,  2722,  2725,  2746,  2749,  2759,  2764,  2769,
    2777,  2785,  2790,  2798,  2799,  2805,  2813,  2814,  2817,  2822,
    2826,  2829,  2840,  2841,  2846,  2849,  2850,  2854,  2857,  2863,
    2866,  2872,  2887,  2898,  2899,  2910,  2921,  2926,  2932,  2947,
    2955,  2958,  2961,  2964,  2967,  2970,  2973,  2979,  2980,  2981,
    2985,  2991,  2994,  3002,  3010,  3018,  3029,  3032,  3035,  3043,
    3046,  3052,  3055,  3063,  3064,  3065,  3066,  3081,  3082,  3083,
    3087,  3091,  3102,  3106,  3117,  3125,  3128,  3131,  3134,  3140,
    3143,  3150,  3153,  3159,  3166,  3167,  3171,  3207,  3214,  3231,
    3236,  3246,  3251,  3256,  3260,  3270,  3276,  3283,  3286,  3292,
    3295,  3298,  3301,  3307,  3310,  3313,  3319,  3320,  3326,  3329,
    3332,  3338,  3341,  3353,  3356,  3359,  3363,  3366,  3369,  3375,
    3378,  3382,  3383,  3390,  3391,  3395,  3396,  3397,  3403,  3404,
    3408,  3409,  3418,  3430,  3431,  3441,  3442,  3453,  3452,  3462,
    3461,  3470,  3473,  3478,  3485,  3484,  3499,  3502,  3506,  3509,
    3512,  3519,  3526,  3532,  3533,  3536,  3542,  3548,  3551,  3554,
    3560,  3561,  3567,  3573,  3576,  3582,  3585,  3585,  3593,  3596,
    3603,  3608
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of input\"", "error", "$undefined", "PREC_BOT",
  "REPEAT_IDENTIFIER", "\"\\\\repeat\"", "\"\\\\alternative\"",
  "COMPOSITE", "\"\\\\addlyrics\"", "':'", "'^'", "'_'",
  "DURATION_IDENTIFIER", "\"__\"", "\"--\"", "EVENT_FUNCTION",
  "EVENT_IDENTIFIER", "E_UNSIGNED", "REAL", "UNSIGNED",
  "NUMBER_IDENTIFIER", "PREC_TOP", "\"\\\\accepts\"", "\"\\\\alias\"",
  "\"\\\\book\"", "\"\\\\bookpart\"", "\"\\\\change\"",
  "\"\\\\chordmode\"", "\"\\\\chords\"", "\"\\\\consists\"",
  "\"\\\\context\"", "\"\\\\default\"", "\"\\\\defaultchild\"",
  "\"\\\\denies\"", "\"\\\\description\"", "\"\\\\drummode\"",
  "\"\\\\drums\"", "\"\\\\figuremode\"", "\"\\\\figures\"",
  "\"\\\\header\"", "\"\\\\version-error\"", "\"\\\\layout\"",
  "\"\\\\lyricmode\"", "\"\\\\lyrics\"", "\"\\\\lyricsto\"",
  "\"\\\\markup\"", "\"\\\\markuplist\"", "\"\\\\midi\"", "\"\\\\name\"",
  "\"\\\\notemode\"", "\"\\\\override\"", "\"\\\\paper\"",
  "\"\\\\remove\"", "\"\\\\rest\"", "\"\\\\revert\"", "\"\\\\score\"",
  "\"\\\\sequential\"", "\"\\\\set\"", "\"\\\\simultaneous\"",
  "\"\\\\tempo\"", "\"\\\\type\"", "\"\\\\unset\"", "\"\\\\with\"",
  "\"\\\\new\"", "\"/+\"", "\"^\"", "\":\"", "\"-\"", "\"/\"", "\"<\"",
  "\">\"", "\"<<\"", "\">>\"", "\"\\\\\"", "\"\\\\!\"", "\"\\\\+\"",
  "FIGURE_CLOSE", "FIGURE_OPEN", "\"_\"", "MULTI_MEASURE_REST",
  "\"markup?\"", "\"scheme?\"", "\"(backed-up?)\"", "\"(reparsed?)\"",
  "\"markup-list?\"", "\"optional?\"", "EXPECT_NO_MORE_ARGS", "\"#{\"",
  "BOOK_IDENTIFIER", "CHORD_BODY_IDENTIFIER", "CHORD_MODIFIER",
  "CHORD_REPETITION", "CONTEXT_DEF_IDENTIFIER", "CONTEXT_MOD_IDENTIFIER",
  "DRUM_PITCH", "PITCH_IDENTIFIER", "PITCH_ARG", "FRACTION",
  "LYRIC_ELEMENT", "MARKUP_FUNCTION", "MARKUP_LIST_FUNCTION",
  "MARKUP_IDENTIFIER", "MARKUPLIST_IDENTIFIER", "MUSIC_FUNCTION",
  "MUSIC_IDENTIFIER", "NOTENAME_PITCH", "OUTPUT_DEF_IDENTIFIER",
  "RESTNAME", "SCM_ARG", "SCM_FUNCTION", "SCM_IDENTIFIER", "SCM_TOKEN",
  "STRING", "SYMBOL_LIST", "TONICNAME_PITCH", "'-'", "'+'", "UNARY_MINUS",
  "'{'", "'}'", "'='", "'.'", "'\\''", "','", "'!'", "'*'", "']'", "'/'",
  "'['", "'?'", "$accept", "start_symbol", "$@1", "lilypond",
  "toplevel_expression", "$@2", "embedded_scm_bare", "embedded_scm_active",
  "embedded_scm_bare_arg", "embedded_scm", "embedded_scm_arg",
  "scm_function_call", "embedded_lilypond", "lilypond_header_body",
  "lilypond_header", "assignment_id", "assignment", "identifier_init",
  "context_def_spec_block", "context_mod_arg", "$@3",
  "context_mod_embedded", "context_def_spec_body", "book_block",
  "book_body", "$@4", "bookpart_block", "bookpart_body", "$@5",
  "score_block", "score_headers", "$@6", "score_body", "$@7",
  "paper_block", "output_def", "output_def_head",
  "output_def_head_with_mode_switch", "music_or_context_def",
  "output_def_body", "$@8", "tempo_event", "music_list",
  "braced_music_list", "music", "music_embedded", "music_embedded_backup",
  "music_arg", "music_assign", "repeated_music", "sequential_music",
  "simultaneous_music", "simple_music", "context_modification", "$@9",
  "context_modification_arg", "optional_context_mod", "context_mod_list",
  "composite_music", "closed_music", "music_bare", "grouped_music_list",
  "function_arglist_nonbackup_common", "function_arglist_closed_nonbackup",
  "symbol_list_arg", "symbol_list_rev", "symbol_list_part",
  "symbol_list_element", "function_arglist_nonbackup",
  "function_arglist_nonbackup_reparse", "function_arglist_backup",
  "function_arglist", "function_arglist_skip_nonbackup",
  "function_arglist_common", "function_arglist_common_reparse",
  "function_arglist_closed", "function_arglist_closed_common",
  "function_arglist_optional", "function_arglist_skip_backup",
  "embedded_scm_closed", "embedded_scm_arg_closed",
  "scm_function_call_closed", "music_function_call", "optional_id",
  "complex_music", "complex_music_prefix", "mode_changed_music",
  "mode_changing_head", "mode_changing_head_with_context", "new_lyrics",
  "$@10", "$@11", "re_rhythmed_music", "$@12", "context_change",
  "property_path", "property_operation", "revert_arg", "revert_arg_backup",
  "revert_arg_part", "context_def_mod", "context_mod", "grob_prop_spec",
  "grob_prop_path", "context_prop_spec", "simple_music_property_def",
  "simple_revert_context", "music_property_def", "string", "simple_string",
  "symbol", "scalar", "event_chord", "note_chord_element", "chord_body",
  "chord_body_elements", "chord_body_element", "music_function_chord_body",
  "music_function_call_closed", "event_function_event", "command_element",
  "command_event", "post_events", "post_event_nofinger", "post_event",
  "string_number_event", "direction_less_event", "direction_reqd_event",
  "octave_check", "quotes", "sup_quotes", "sub_quotes", "steno_pitch",
  "steno_tonic_pitch", "pitch", "pitch_arg", "gen_text_def", "fingering",
  "script_abbreviation", "script_dir", "duration_length",
  "maybe_notemode_duration", "optional_notemode_duration",
  "steno_duration", "multiplied_duration", "dots", "tremolo_type",
  "bass_number", "figured_bass_alteration", "bass_figure",
  "figured_bass_modification", "br_bass_figure", "figure_list",
  "figure_spec", "optional_rest", "simple_element",
  "simple_chord_elements", "lyric_element", "lyric_element_music",
  "new_chord", "chord_items", "chord_separator", "chord_item",
  "step_numbers", "step_number", "tempo_range", "number_expression",
  "number_term", "number_factor", "bare_number_common",
  "bare_number_common_closed", "bare_number", "bare_number_closed",
  "unsigned_number", "exclamations", "questions", "full_markup_list",
  "$@13", "full_markup", "$@14", "markup_top", "markup_scm", "$@15",
  "markup_list", "markup_uncomposed_list", "markup_composed_list",
  "markup_braced_list", "markup_braced_list_body", "markup_command_list",
  "markup_command_basic_arguments", "markup_command_list_arguments",
  "markup_head_1_item", "markup_head_1_list", "simple_markup", "$@16",
  "markup", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,    58,
      94,    95,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,    45,    43,   367,   123,   125,
      61,    46,    39,    44,    33,    42,    93,    47,    91,    63
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   130,   131,   132,   131,   133,   133,   133,   133,   133,
     135,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   136,   136,   137,   137,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   139,   139,   140,   140,
     140,   141,   142,   142,   142,   142,   142,   143,   143,   143,
     144,   145,   146,   146,   146,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   148,   149,
     150,   149,   151,   152,   152,   152,   152,   152,   153,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   155,
     154,   154,   156,   157,   157,   157,   157,   157,   157,   157,
     157,   157,   158,   157,   157,   159,   160,   161,   160,   160,
     162,   162,   163,   162,   162,   162,   164,   165,   166,   166,
     166,   167,   168,   168,   169,   169,   169,   169,   170,   169,
     169,   171,   171,   171,   172,   172,   172,   173,   174,   174,
     175,   175,   175,   176,   177,   177,   178,   178,   179,   179,
     179,   179,   180,   180,   181,   181,   182,   182,   182,   184,
     183,   183,   183,   183,   185,   185,   186,   186,   187,   187,
     187,   187,   188,   188,   189,   189,   189,   190,   190,   190,
     191,   191,   192,   192,   192,   192,   193,   193,   193,   193,
     193,   193,   193,   194,   194,   195,   195,   196,   197,   197,
     198,   198,   198,   198,   198,   198,   198,   198,   198,   199,
     199,   199,   199,   199,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   200,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   200,   200,   200,   200,   201,   201,   202,
     202,   203,   203,   203,   203,   203,   203,   203,   203,   203,
     203,   204,   204,   204,   204,   204,   204,   204,   205,   205,
     206,   206,   206,   206,   206,   206,   206,   206,   207,   207,
     207,   208,   208,   209,   209,   210,   210,   210,   211,   212,
     213,   213,   214,   214,   214,   214,   215,   215,   216,   216,
     217,   217,   217,   217,   217,   218,   218,   218,   218,   220,
     219,   221,   219,   222,   223,   222,   224,   225,   225,   226,
     226,   226,   226,   227,   228,   229,   229,   229,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   231,   231,   231,
     232,   233,   233,   234,   235,   235,   235,   235,   236,   237,
     238,   238,   239,   239,   240,   240,   241,   241,   241,   241,
     241,   241,   242,   242,   242,   242,   242,   242,   243,   244,
     244,   245,   245,   246,   246,   246,   247,   247,   247,   248,
     249,   250,   251,   252,   252,   253,   253,   253,   253,   253,
     253,   253,   253,   254,   254,   255,   256,   256,   256,   256,
     257,   257,   258,   258,   259,   259,   259,   260,   260,   261,
     261,   262,   263,   264,   264,   265,   266,   266,   266,   267,
     268,   268,   268,   268,   268,   268,   268,   269,   269,   269,
     270,   271,   271,   272,   273,   273,   274,   274,   274,   275,
     275,   276,   276,   277,   277,   277,   277,   278,   278,   278,
     279,   279,   279,   279,   279,   280,   280,   280,   280,   281,
     281,   282,   282,   283,   284,   284,   285,   285,   285,   286,
     286,   287,   287,   287,   288,   289,   289,   290,   290,   291,
     291,   291,   291,   292,   292,   292,   293,   293,   294,   294,
     294,   295,   295,   296,   296,   296,   297,   297,   297,   298,
     298,   299,   299,   300,   300,   301,   301,   301,   302,   302,
     303,   303,   303,   304,   304,   305,   305,   307,   306,   309,
     308,   310,   310,   310,   312,   311,   313,   313,   314,   314,
     314,   315,   316,   317,   317,   317,   318,   319,   319,   319,
     320,   320,   321,   322,   322,   323,   324,   323,   323,   323,
     325,   325
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     3,     0,     2,     2,     2,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     0,     1,     3,     1,     2,     0,     2,     2,
       4,     1,     3,     4,     5,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     4,     1,
       0,     2,     1,     0,     1,     2,     2,     2,     4,     0,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     0,
       3,     2,     4,     0,     1,     2,     2,     2,     2,     2,
       2,     2,     0,     3,     2,     4,     0,     0,     3,     2,
       2,     1,     0,     3,     2,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     2,     3,     2,     2,     0,     3,
       2,     4,     5,     2,     0,     2,     2,     3,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     4,     2,
       6,     4,     2,     1,     2,     3,     1,     1,     1,     0,
       5,     2,     1,     2,     1,     1,     0,     1,     0,     2,
       2,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     4,     5,     5,     5,     1,     1,     4,     4,
       4,     4,     4,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     4,     4,     3,     3,     3,     3,     3,     4,
       4,     4,     4,     4,     1,     4,     6,     4,     4,     4,
       4,     4,     4,     5,     5,     5,     4,     4,     4,     4,
       4,     4,     3,     3,     3,     3,     3,     1,     4,     1,
       3,     1,     3,     3,     3,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     4,     1,     4,
       1,     3,     3,     4,     3,     3,     3,     3,     1,     4,
       2,     1,     3,     1,     1,     1,     1,     1,     2,     2,
       0,     2,     1,     1,     1,     2,     4,     4,     2,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       3,     0,     4,     2,     0,     4,     4,     1,     2,     3,
       2,     4,     2,     3,     1,     1,     5,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     1,     2,     1,     4,     3,     4,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     2,     2,     3,     3,     1,     1,     3,     3,
       1,     0,     2,     5,     2,     1,     1,     1,     1,     2,
       2,     1,     1,     0,     2,     1,     2,     1,     1,     2,
       2,     2,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     0,     1,     1,     1,     2,     1,
       2,     2,     2,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     2,     2,     1,     3,     3,     0,
       2,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       2,     0,     2,     3,     0,     1,     6,     2,     2,     1,
       2,     1,     1,     1,     3,     2,     4,     0,     2,     1,
       1,     2,     2,     1,     1,     1,     1,     3,     1,     2,
       2,     1,     3,     3,     3,     1,     1,     3,     3,     2,
       1,     1,     2,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     0,     2,     0,     2,     0,     3,     0,
       3,     1,     2,     1,     0,     3,     1,     1,     1,     1,
       2,     2,     3,     0,     2,     2,     2,     3,     3,     1,
       1,     3,     3,     1,     2,     1,     0,     5,     2,     2,
       2,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       5,     3,     0,     0,     0,     1,     8,     0,     0,     0,
       0,   293,   297,     0,   291,   295,   292,   296,     9,   120,
     294,   298,     0,   509,   507,   119,   290,   118,     0,     0,
       0,     0,   134,    14,     0,   178,     0,    24,    19,    51,
     134,     6,     0,    20,    25,     0,     7,    12,    13,    15,
      21,   121,     0,     0,   153,   283,   181,   180,    16,   173,
     179,   282,   172,     0,   177,     0,   166,   284,    18,    17,
      45,   431,   418,   417,   378,   377,     0,   387,   385,   493,
     496,   494,     0,     0,     0,     0,     0,     0,     0,     0,
     159,   361,   451,   421,   360,   421,   162,   421,   394,    63,
     463,   394,   421,    23,    22,   462,   394,   419,    36,   143,
      37,     4,    43,    59,    56,    57,    55,    58,   372,   140,
       0,   141,   138,    60,   144,    67,   145,   158,   339,   157,
      64,   156,   357,   421,   389,   356,   371,   373,   386,   375,
     403,   421,   503,     0,   388,   421,   373,   373,   421,   139,
     459,    62,   485,   486,   495,   491,   490,    66,   461,   462,
     149,   144,   145,   461,   342,   343,     0,    79,    93,   344,
     345,   280,   304,     0,     0,   106,   152,   154,   280,     0,
       0,     0,   241,   200,   237,     0,   279,   201,     0,    41,
       0,     0,    11,   198,     0,     0,   199,   307,   195,   197,
       0,   124,   130,   117,   127,   126,     0,   299,   303,   285,
     288,   167,     0,   432,   409,   381,   382,     0,     0,   260,
     186,   258,     0,   370,   187,   492,   497,     0,    73,    46,
     330,   331,     0,   338,     0,   333,     0,   429,   496,    28,
      26,   347,    27,   350,     0,    38,   346,    39,    32,    33,
      34,    31,    35,    40,   146,    30,   147,   133,     0,   348,
      29,   351,   337,   161,   165,     0,   273,     0,   163,   164,
     274,     0,     0,   429,   423,   373,   426,   422,   373,   457,
     397,   399,   404,   396,   395,   401,   458,   402,     0,   489,
     143,   134,     0,   373,    61,   465,     0,   505,   410,   416,
     414,     0,   407,   412,   411,   415,   413,   408,   376,   380,
     379,   390,   391,   406,   460,   352,   353,   373,     0,     0,
       0,     0,     0,   500,   501,   502,     0,    80,     0,    94,
       0,     0,   166,     0,   536,     0,     0,   535,   523,   514,
     510,     0,   511,   517,   516,   518,   519,   533,     0,   513,
       0,     0,   508,     0,   111,   107,     0,   166,   136,   155,
     135,     0,   268,   214,     0,     0,     0,     0,     0,   137,
      47,   340,    65,    52,   341,     0,     0,   308,     0,   125,
     123,   129,   122,     0,   301,   289,     0,     0,     0,     0,
      74,    70,   332,     0,   315,   335,     0,   314,     0,   425,
     424,   349,     0,     0,   278,   168,   359,   373,   367,   368,
     366,   362,   365,   503,   433,   453,   440,   434,     0,   436,
     441,   449,   452,   435,   355,     0,   354,   398,   400,     0,
     142,   358,   419,   383,   374,     0,   470,   469,     0,   467,
     504,   392,   369,   464,   484,   483,   487,   488,   151,   148,
      91,    87,    78,    88,     0,    82,    83,    81,   116,    84,
      86,    85,   104,   100,    92,   101,     0,    96,    95,    97,
      99,    98,   281,   286,   305,     0,     0,     0,     0,   529,
     538,     0,   530,   526,     0,     0,   539,   520,   521,   534,
     512,     0,   109,   110,   115,   105,     0,   114,   287,     0,
       0,   255,   254,   251,   252,   419,   242,   244,   243,   253,
     270,     0,   239,     0,   206,   193,   208,   204,   420,   207,
     205,   246,   250,   249,   247,   248,     0,     0,   196,    53,
     300,     0,   493,   419,   275,   277,   174,   261,   276,     0,
     176,   264,   262,   239,     0,   265,   267,   266,   306,   320,
     323,   318,   321,   322,   325,   326,     0,   319,     0,   324,
       0,    68,    36,    69,    72,     0,    77,    76,   327,     0,
      75,     0,   334,     0,   336,   430,     0,   131,   481,    70,
     364,   505,   450,   448,   446,   445,   437,   438,   439,   442,
     447,   443,   444,   427,   428,   384,   472,   471,   466,   394,
     506,   421,     0,    90,   103,   106,   532,     0,     0,     0,
     522,   525,     0,   541,   524,   515,   108,   113,     0,   271,
     272,   394,   232,   236,   233,   235,   234,   257,   256,   245,
       0,   213,   212,   209,   210,   419,   202,   182,   203,   211,
     238,     0,    50,    49,    48,    54,   302,   263,   175,   498,
     190,   191,   188,   499,   189,   192,   259,     0,   312,   310,
      71,   328,   329,     0,     0,   313,   132,     0,   170,   160,
     171,   169,   392,   478,   475,   473,   468,   474,   476,   393,
     454,   150,     0,   528,   527,     0,     0,   531,   540,     0,
       0,   229,   221,   220,   222,   226,   227,   230,   231,   228,
     419,   215,   217,   218,   219,   269,   405,   240,   184,   183,
     185,   194,     0,   309,     0,   317,   482,   373,   480,   479,
       0,   455,   456,   537,   272,     0,   224,   223,   225,   311,
     316,   363,   477,   216
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,    41,    42,   108,   354,   245,   325,
     246,   110,   111,   526,   192,    45,    46,   112,   248,   564,
     565,   566,   391,   249,   328,   454,   250,   330,   466,   251,
     355,   491,   356,   496,   457,   252,    51,    52,   381,    53,
     206,   118,   179,    54,   119,   360,   121,   122,   253,    55,
      56,    57,   254,   255,   267,   268,   212,   579,   256,   535,
      59,    60,   183,   221,   516,   197,   198,   199,   184,   185,
     362,   186,   513,   187,   188,   223,   224,   364,   365,   269,
     537,   270,    61,   332,    62,    63,    64,    65,    66,   208,
     383,   531,    67,   333,   127,   200,   568,   395,   396,   397,
     569,   570,   231,   232,   236,   128,   234,   129,   130,   166,
     171,   257,   131,   132,   133,   271,   411,   412,   540,   134,
     135,   136,   294,   433,   434,   138,   139,   310,   601,   282,
     283,   284,   140,   141,   142,   624,   311,   215,   312,   143,
     517,   274,   275,   276,   277,   400,   144,   420,   591,   421,
     592,   422,   272,   145,   722,   146,   147,   148,   149,   150,
     598,   439,   676,   677,   678,   577,   151,   152,   153,   154,
     155,   156,   654,   578,   297,   441,   260,   174,   163,   173,
     340,   341,   485,   342,   343,   344,   345,   484,   346,   482,
     483,   347,   353,   613,   475,   614
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -440
static const yytype_int16 yypact[] =
{
      20,  -440,   139,  1098,   716,  -440,  -440,  2374,   309,    28,
      46,  -440,  -440,   436,  -440,  -440,  -440,  -440,  -440,  -440,
    -440,  -440,   309,  -440,  -440,  -440,  -440,  -440,    75,    99,
      99,   436,  -440,  -440,    95,  -440,    95,  -440,  -440,  -440,
    -440,  -440,   138,  -440,  -440,    15,  -440,  -440,  -440,  -440,
    -440,  -440,   134,  1002,  -440,  -440,  -440,  -440,   194,  -440,
    -440,  -440,  -440,  2374,  -440,   100,    36,  -440,  -440,  -440,
    -440,   221,   239,   239,  -440,  -440,   192,  -440,  -440,   193,
     250,  -440,   436,   371,   716,   501,   501,   501,  1883,   501,
     364,  -440,  -440,   122,  -440,   122,  -440,   122,   125,  -440,
    -440,   125,   122,  -440,  -440,   275,   125,   636,  -440,   288,
    -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,
    2089,   215,  -440,  -440,   308,  -440,   123,  -440,  -440,  -440,
    -440,  -440,  -440,   122,  -440,  -440,  -440,  -440,  -440,  -440,
    -440,   122,  -440,  1429,  -440,   122,  -440,  -440,   122,  -440,
    -440,   152,  -440,    81,  -440,  -440,  -440,  -440,   319,  -440,
     318,  -440,   194,  -440,  -440,  -440,   428,   238,   241,  -440,
    -440,   211,  -440,   565,   353,   171,  -440,  -440,   211,  1358,
     217,   270,  -440,  -440,  -440,   257,  -440,  -440,   273,  -440,
     811,   258,  -440,  -440,  1771,   501,  -440,   385,  -440,  -440,
     251,   278,  -440,  -440,  -440,  -440,  2469,  -440,   351,  -440,
    -440,  -440,   100,  -440,  -440,  -440,  -440,   217,   310,  -440,
    -440,  -440,   313,  -440,  -440,  -440,  -440,   282,   321,  -440,
     311,   501,   338,  -440,   501,   311,   339,  -440,    74,  -440,
    -440,  -440,  -440,  -440,   636,  -440,  -440,  -440,  -440,  -440,
    -440,  -440,  -440,  -440,  -440,  -440,   194,   122,   341,  -440,
    -440,  -440,  -440,  -440,  -440,   192,  -440,   323,  -440,  -440,
    -440,   782,   144,  -440,  -440,  -440,  -440,   344,  -440,  -440,
    -440,  -440,  -440,   348,   349,  -440,  -440,  -440,   130,  -440,
    -440,  -440,    87,  -440,   420,   462,   542,   356,  -440,  -440,
    -440,   192,  -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,
    -440,  -440,  -440,  -440,  -440,   420,   420,  -440,   130,   130,
     130,   130,    99,  -440,  -440,  -440,  2374,  -440,  1187,  -440,
    1272,   309,    36,  2374,  -440,   205,   253,  -440,  -440,  -440,
    -440,   272,  -440,  -440,  -440,  -440,  -440,  -440,   565,  -440,
     413,   396,  -440,   353,  -440,  2184,   118,    36,  -440,  -440,
    -440,   423,   271,  -440,  1547,   425,   228,   405,   581,  -440,
    -440,  -440,  -440,  -440,  -440,   388,   501,  -440,  1771,  -440,
    -440,  -440,  -440,  2561,  -440,  -440,  2735,   228,    90,   309,
    -440,  2918,  -440,  1995,  -440,  -440,   433,  -440,  1995,   389,
     389,  -440,   399,   428,  -440,  -440,  -440,  -440,  -440,  -440,
    -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,   234,  -440,
    -440,   417,  -440,  -440,   420,    85,   420,  -440,  -440,   907,
    -440,   420,   239,  -440,  -440,   402,  -440,  -440,   402,  -440,
    -440,    31,  -440,   420,  -440,  -440,  -440,  -440,  -440,   515,
    -440,  -440,  -440,  -440,   138,  -440,  -440,  -440,  -440,   194,
    -440,  -440,  -440,  -440,  -440,  -440,   138,  -440,  -440,   194,
    -440,  -440,  -440,  -440,  -440,   432,   253,   253,   253,  -440,
    -440,   253,  -440,  -440,   367,   449,  -440,  -440,  -440,  -440,
    -440,   138,  -440,  -440,  -440,  -440,   138,  -440,  -440,   358,
    2281,  -440,  -440,  -440,  -440,   666,  -440,  -440,  -440,  -440,
    -440,   472,  1659,   525,  -440,   437,  -440,  -440,   344,  -440,
    -440,  -440,  -440,  -440,  -440,  -440,   524,  1771,  -440,  -440,
    -440,  2561,  -440,   672,  -440,  -440,  -440,  -440,  -440,   610,
    -440,  -440,  -440,  2845,   531,  -440,  -440,  -440,  -440,  -440,
    -440,  -440,  -440,  -440,  -440,  -440,   501,  -440,   501,  -440,
     436,  -440,   451,  -440,  -440,  2561,  -440,  -440,  -440,   486,
    -440,   452,  -440,    84,  -440,  -440,   428,  -440,   460,  2942,
     420,   356,   417,  -440,  -440,  -440,  -440,  -440,  -440,  -440,
    -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,   252,   125,
    -440,   122,    99,  -440,  -440,   171,  -440,   588,   353,   237,
    -440,  -440,   565,  -440,  -440,  -440,  -440,  -440,   497,  2625,
     552,   125,  -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,
     228,  -440,  -440,  -440,  -440,   683,  -440,  -440,  -440,  -440,
    -440,   501,  -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,
    -440,  -440,  -440,  -440,  -440,  -440,  -440,   467,  -440,  -440,
     194,  -440,  -440,  1995,   453,  -440,  -440,   428,  -440,  -440,
    -440,  -440,    31,    54,  -440,  -440,  -440,   470,  -440,  -440,
     535,  -440,   127,  -440,  -440,   502,   237,  -440,  -440,   358,
     309,  -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,
     687,  -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,
    -440,   311,  1995,  -440,   501,  -440,  -440,  -440,  -440,  -440,
     583,  -440,  -440,  -440,  -440,   428,  -440,  -440,  -440,  -440,
    -440,   420,  -440,  -440
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -440,  -440,  -440,  -440,  -440,  -440,    10,    79,  -332,    25,
    -280,     0,   541,  -440,  -324,  -440,   -39,  -145,    33,  -440,
    -440,    52,  -440,    30,  -440,  -440,    40,  -440,  -440,    27,
    -440,  -440,     4,  -440,   298,    22,  -440,  -440,  -440,  -440,
    -440,  -440,     8,   -21,    39,   116,  -440,   435,    34,  -440,
    -440,  -440,   259,    49,  -440,  -440,  -219,  -440,    59,   103,
    -329,    18,    -8,  -440,  -299,   -68,   -82,  -440,  -326,  -440,
    -439,   603,  -335,  -167,    -1,  -128,  -440,   427,  -428,  -123,
    -431,  -312,   378,   479,  -440,  -314,  -440,  -440,  -440,  -440,
    -440,  -440,  -440,  -440,  -440,  -130,  -440,    92,  -440,  -440,
    -440,    82,  -440,  -440,   569,  -440,  -440,  -440,  -440,   -20,
     -24,  -342,  -440,  -440,    43,  -440,  -440,  -440,   526,  -440,
    -440,  -440,  -131,     2,  -440,  -440,   528,  -440,    -5,   -79,
    -440,  -440,  -440,  -176,   401,  -440,  -440,   -28,  -440,  -440,
    -288,  -102,   482,   -15,  -291,   441,  -440,  -440,  -440,   262,
    -440,  -440,  -440,  -440,  -440,  -440,  -440,  -440,  -213,  -440,
    -440,    89,  -440,  -440,   -38,   119,  -440,   137,   -37,  -277,
    -283,   -83,  -440,  -156,   295,   129,    32,  -440,    -3,  -440,
    -440,  -163,  -440,  -146,  -306,  -440,  -440,  -440,  -440,   376,
      24,  -289,  -149,  -161,  -440,   106
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -430
static const yytype_int16 yytable[] =
{
      69,   158,   172,    44,   233,   259,   137,   178,   176,   177,
     326,   351,   349,   363,   205,   315,   316,   230,   165,   235,
     307,   235,   285,   170,   348,    50,   117,   287,   352,   109,
      49,   116,   165,    47,   114,    68,   157,   113,   123,   295,
     512,   170,   488,    48,   115,   216,   160,   488,   190,   373,
     363,   572,   544,   125,   534,   196,   574,   536,   227,   489,
     619,   543,    58,   126,   489,   375,   162,   377,   220,   522,
     289,   620,   539,   258,   538,   222,   518,   518,   204,   430,
     523,   158,    43,   210,   506,   261,   137,   508,   247,   546,
     520,   525,   170,   170,   226,   196,   196,   196,    90,   196,
     266,   392,   209,   542,   593,   547,   117,     1,   532,   109,
      81,   116,   652,   473,   114,   211,   157,   113,   123,   494,
     120,   718,   162,  -147,   115,   103,   104,   193,   494,    96,
     603,   207,    23,   125,   237,   194,   195,   404,   498,     5,
     313,   273,   604,   126,   424,   290,   167,   426,    79,    80,
      81,   599,   394,   266,   519,   524,    29,  -112,    30,    19,
     600,   401,   431,   414,   168,    25,  -112,   616,    19,    27,
     719,    32,   617,   442,    25,    44,   180,   191,    27,   162,
     181,   182,   594,   339,   339,   100,   443,   490,   701,    23,
     351,   374,   664,   175,  -429,  -429,   137,   515,   545,   159,
     120,   623,   207,   515,   290,   196,   320,   196,   321,   518,
     536,   534,   625,   225,   536,   290,   117,    40,    40,   372,
     415,   116,   416,   626,   114,   539,   157,   113,   123,   539,
     385,   538,   636,   529,   115,   638,   291,   495,   162,   380,
     213,   196,   402,   125,   196,   288,   723,   280,   281,   162,
     619,   289,   201,   414,   103,   104,   417,   220,   214,   596,
     653,   724,   597,   124,   222,   162,   161,   318,   319,   423,
     226,   673,   418,   217,   665,  -340,   580,   218,   219,    23,
      36,    37,   419,   446,   447,   476,   477,   534,   -65,   478,
     536,   479,   334,   220,   528,   707,   409,   292,   180,   429,
     222,   448,   361,   182,   512,   539,   488,   538,  -146,   180,
     259,   472,   416,   511,   182,   259,   435,   436,   437,  -341,
     438,   713,   161,   489,   322,   461,   327,   471,    44,   329,
      44,   331,   363,   481,   477,   612,   335,   478,   611,   479,
     367,   165,   674,   124,   103,   104,   417,   103,   104,   337,
     458,   366,   458,  -271,   500,   456,   368,   467,   339,   384,
     460,   509,   470,   339,   247,   449,   507,   571,   455,   548,
     729,   378,   474,   486,   487,   374,   370,   492,   497,   161,
     137,   211,   645,   509,   379,   162,   196,   459,   541,   469,
     261,   387,   162,   247,   493,   261,   388,   489,   247,   165,
     117,   562,   389,   372,   595,   116,   211,   453,   114,   465,
     157,   113,   123,   390,   162,   423,   563,   237,   115,   103,
     104,   164,   334,    79,   273,    81,   657,   125,   419,    71,
      72,    73,   376,    74,    75,    76,    77,    78,   161,   180,
     567,   405,   530,   618,   182,   351,   685,   323,   324,   161,
      23,   688,   350,   336,   290,   444,   445,   263,   393,   398,
     686,   403,   684,   103,   104,   161,   335,   336,   264,   425,
     427,   338,   428,   265,   103,   104,   394,   103,   104,   337,
     440,   103,   104,   169,   683,   338,   610,   644,   162,   228,
     583,   584,   585,   476,   339,   103,   104,   193,   487,   680,
     606,   607,   608,   100,   499,   609,   376,   510,   527,   639,
     575,   716,   247,   514,   637,   573,   106,   159,   515,   576,
     679,   602,   363,   685,   374,   688,  -423,  -423,  -423,   137,
    -423,   615,   586,   587,   622,   432,   659,    36,   103,   104,
     655,   588,   706,   589,   590,   637,   103,   104,   169,   117,
     605,   643,   372,   630,   116,   571,   640,   114,   641,   157,
     113,   123,   656,   103,   104,   193,   196,   115,   196,   733,
     170,  -345,   663,   711,   714,   667,   125,   278,   689,   279,
     259,   681,   715,   705,   286,   161,   731,   712,   721,   562,
     646,   720,   161,   237,   662,    36,   103,   104,   661,    79,
     273,    81,   673,   486,   563,    44,   435,   436,   437,   682,
     438,   103,   104,   193,   161,   293,   704,   266,   339,   339,
     334,   703,   339,   296,   660,   229,    23,   314,   468,   259,
     317,   670,   730,    36,   103,   104,    39,    11,    12,   189,
      13,   382,   648,   642,   386,    14,    15,    16,    17,   410,
     658,   196,    20,    21,    79,    80,    81,   357,   262,    26,
     261,   671,   702,   247,   335,   336,    29,   717,    30,   308,
     725,   309,   413,    31,   196,   103,   104,   337,   399,   100,
     582,    32,   732,   338,   627,   628,   629,   675,   161,   521,
     627,   628,   647,   159,   515,   666,   339,   265,   103,   104,
     165,   708,   709,   710,   497,   726,   727,   728,   581,   261,
     672,   480,   247,   301,    35,   687,   -42,    70,     0,     0,
       7,     8,     0,     0,   196,    71,    72,    73,    40,    74,
      75,    76,    77,    78,    79,    80,    81,     0,     0,     0,
       9,    10,    82,    11,    12,     0,    83,     0,     0,     0,
       0,    14,    15,    16,    17,     0,    84,    19,    20,    21,
      22,    23,    24,    25,     0,    26,    85,    27,     0,     0,
      86,    28,    29,    87,    30,    88,     0,    89,    90,    31,
       0,     0,     0,     0,     0,    91,     0,    32,     0,     0,
       0,     0,     0,    92,     0,    93,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    94,     0,    95,     0,    96,
      97,    98,   358,    99,   100,     7,     8,     0,     0,    34,
      35,   101,     0,   102,     0,    36,   103,   104,   105,     0,
     106,   107,     0,     0,    40,     0,     0,    82,    11,    12,
       0,    13,     0,     0,     0,     0,    14,    15,    16,    17,
       0,     0,   406,    20,    21,    22,    23,     0,     0,     0,
      26,    85,     0,     0,     0,    86,     0,    29,    87,    30,
      88,     0,    89,     0,    31,     0,   407,    98,     0,     0,
      91,     0,    32,     0,     0,    34,   408,   101,    92,     0,
      93,    36,   103,   104,     0,     0,     0,     0,     0,     0,
      94,     0,    95,     0,     0,    97,    98,   -44,   358,   100,
       0,     7,     8,     0,    34,    35,   101,     0,   102,     0,
      36,   103,   104,   159,     0,   106,     0,     0,     0,    40,
     369,     0,     0,    82,    11,    12,     0,    13,     0,     0,
       0,     0,    14,    15,    16,    17,     0,     0,     0,    20,
      21,    22,    23,     0,     0,     0,    26,    85,     0,     0,
       0,    86,     0,    29,    87,    30,    88,     0,    89,     0,
      31,     0,     0,     0,     0,     0,    91,     0,    32,     0,
       0,     0,     0,     0,    92,     0,    93,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    94,     0,    95,     0,
       0,    97,    98,   202,     0,   100,  -128,  -128,     0,     0,
      34,    35,   101,     0,   102,     0,    36,   103,   104,   159,
       0,   106,     0,     0,     0,    40,     0,     0,  -128,  -128,
    -128,     0,  -128,     0,     0,     0,     0,  -128,  -128,  -128,
    -128,     0,     0,     0,  -128,  -128,  -128,     0,     0,     0,
       0,  -128,  -128,     0,     0,     0,  -128,     0,  -128,  -128,
    -128,  -128,     0,  -128,     0,  -128,     0,     0,     0,     0,
       0,  -128,     0,  -128,     0,     0,     0,     0,     0,  -128,
       0,  -128,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -128,     0,  -128,     0,     0,  -128,  -128,    -2,     6,
       0,     0,     7,     8,     0,  -128,  -128,  -128,     0,  -128,
       0,    36,   103,   104,    39,     0,  -128,     0,     0,     0,
    -128,   203,     9,    10,     0,    11,    12,     0,    13,     0,
       0,     0,     0,    14,    15,    16,    17,   -10,    18,    19,
      20,    21,    22,    23,    24,    25,     0,    26,     0,    27,
       0,     0,     0,    28,    29,     0,    30,     0,     0,     0,
       0,    31,     0,     0,     0,     0,     0,     0,     0,    32,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    33,     0,   450,     0,
       0,     7,     8,     0,     0,     0,     0,     0,     0,     0,
       0,    34,    35,     0,     0,     0,     0,    36,    37,    38,
      39,     0,    10,     0,    11,    12,    40,    13,     0,     0,
       0,     0,    14,    15,    16,    17,   -89,     0,    19,    20,
      21,    22,    23,    24,    25,     0,    26,     0,    27,     0,
       0,     0,    28,    29,     0,    30,     0,     0,     0,     0,
      31,     0,     0,     0,     0,     0,     0,     0,    32,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   462,     0,     0,     7,     8,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      34,    35,     0,     0,     0,     0,    36,    37,   451,    11,
      12,     0,    13,     0,     0,    40,   452,    14,    15,    16,
      17,  -102,     0,    19,    20,    21,    22,    23,    24,    25,
       0,    26,     0,    27,     0,     0,     0,    28,    29,     0,
      30,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,     0,     0,    32,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   358,
       0,     0,     7,     8,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    35,     0,     0,     0,
       0,    36,    37,   463,    82,    11,    12,     0,    13,     0,
      40,   464,     0,    14,    15,    16,    17,     0,     0,     0,
      20,    21,    22,    23,     0,     0,     0,    26,    85,     0,
       0,     0,    86,     0,    29,    87,    30,    88,     0,    89,
       0,    31,     0,     0,     0,     0,     0,    91,     0,    32,
     359,     0,     0,     0,     0,    92,     0,    93,    71,   298,
     299,     0,     0,     0,    76,    77,    78,    94,     0,    95,
       0,     0,    97,    98,     0,     0,   100,     0,     0,     0,
       0,    34,    35,   101,     0,   102,     0,    36,   103,   104,
     159,     0,   106,     0,    23,     0,    40,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   300,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   301,     0,     0,     0,     0,     0,   265,   103,
     104,   302,     0,     0,   303,   304,     0,     0,     0,     0,
     305,     7,     8,   306,     0,     0,    71,    72,    73,   501,
      74,    75,    76,    77,    78,    79,   502,    81,     0,     0,
       0,     9,    10,    82,    11,    12,     0,    83,     0,     0,
       0,     0,    14,    15,    16,    17,     0,     0,    19,    20,
      21,    22,    23,    24,    25,     0,    26,    85,    27,     0,
       0,    86,    28,    29,    87,    30,    88,     0,    89,    90,
      31,     0,     0,     0,     0,     0,    91,     0,    32,     0,
       0,     0,     0,     0,    92,     0,    93,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    94,     0,    95,     0,
      96,    97,    98,     0,   239,     0,     0,     0,     0,     0,
      34,    35,   101,     0,   102,   240,    36,   503,   242,   504,
       0,   106,   505,     7,     8,    40,     0,     0,    71,    72,
      73,   631,    74,    75,    76,    77,    78,    79,   632,    81,
       0,     0,     0,     9,    10,    82,    11,    12,     0,    83,
       0,     0,     0,     0,    14,    15,    16,    17,     0,     0,
      19,    20,    21,    22,    23,    24,    25,     0,    26,    85,
      27,     0,     0,    86,    28,    29,    87,    30,    88,     0,
      89,    90,    31,     0,     0,     0,     0,     0,    91,     0,
      32,     0,     0,     0,     0,     0,    92,     0,    93,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    94,     0,
      95,     0,    96,    97,    98,     0,   239,     0,     0,     0,
       0,     0,    34,    35,   101,     0,   102,   240,    36,   633,
     242,   634,     0,   106,   635,     7,     8,    40,     0,     0,
      71,    72,    73,     0,    74,    75,    76,    77,    78,    79,
      80,    81,     0,     0,     0,     9,    10,    82,    11,    12,
       0,    83,     0,     0,     0,     0,    14,    15,    16,    17,
       0,     0,    19,    20,    21,    22,    23,    24,    25,     0,
      26,    85,    27,     0,     0,    86,    28,    29,    87,    30,
      88,     0,    89,    90,    31,     0,     0,     0,     0,     0,
      91,     0,    32,     0,     0,     0,     0,     0,    92,     0,
      93,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      94,     0,    95,     0,    96,    97,    98,     0,    99,     0,
       0,     0,     0,     0,    34,    35,   101,     0,   102,     0,
      36,   103,   104,   371,     0,   106,   107,     7,     8,    40,
       0,     0,     0,     0,     0,   237,     0,     0,     0,     0,
       0,    79,   238,    81,     0,     0,     0,     9,    10,    82,
      11,    12,     0,    83,     0,     0,     0,     0,    14,    15,
      16,    17,     0,     0,    19,    20,    21,    22,    23,    24,
      25,     0,    26,    85,    27,     0,     0,    86,    28,    29,
      87,    30,    88,     0,    89,    90,    31,     0,     0,     0,
       0,     0,    91,     0,    32,     0,     0,     0,     0,     0,
      92,     0,    93,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    94,     0,    95,     0,    96,    97,    98,     0,
     239,     0,     0,     0,     0,     0,    34,    35,   101,     0,
     102,   240,    36,   241,   242,   243,     0,   106,   244,     7,
       8,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    79,    80,    81,     0,     0,     0,     9,
      10,    82,    11,    12,     0,    83,     0,     0,     0,     0,
      14,    15,    16,    17,     0,     0,    19,    20,    21,    22,
      23,    24,    25,     0,    26,    85,    27,     0,     0,    86,
      28,    29,    87,    30,    88,     0,    89,    90,    31,     0,
       0,     0,     0,     0,    91,     0,    32,     0,     0,     0,
       0,     0,    92,     0,    93,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    94,     0,    95,     0,    96,    97,
      98,     0,   239,     7,     8,     0,     0,     0,    34,    35,
     101,     0,   102,   240,    36,   241,   242,   243,     0,   106,
     244,     0,     0,    40,     0,    82,    11,    12,     0,    13,
       0,     0,     0,     0,    14,    15,    16,    17,     0,     0,
       0,    20,    21,    22,    23,     0,     0,     0,    26,    85,
       0,     0,     0,    86,     0,    29,    87,    30,    88,     0,
      89,     0,    31,     0,     0,     0,     0,     0,    91,     0,
      32,     0,     0,     0,     0,     0,    92,     0,    93,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    94,     0,
      95,     0,     0,    97,    98,     0,     0,   100,     7,     8,
       0,     0,    34,    35,   101,     0,   102,     0,    36,   103,
     104,   159,     0,   106,     0,     0,     0,    40,     0,     0,
      82,    11,    12,     0,    13,     0,     0,     0,     0,    14,
      15,    16,    17,     0,     0,    19,    20,    21,    22,    23,
       0,    25,     0,    26,    85,    27,     0,     0,    86,     0,
      29,    87,    30,    88,     0,    89,     0,    31,     0,     0,
       0,     0,     0,    91,     0,    32,     0,     0,     0,     0,
       0,    92,     0,    93,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    94,     0,    95,     0,     0,    97,    98,
       0,     0,   100,     0,     0,     7,     8,    34,    35,   101,
       0,   102,     0,   237,     0,     0,   159,     0,   106,    79,
     273,    81,    40,     0,     0,     0,     0,    82,    11,    12,
       0,    13,     0,     0,     0,     0,    14,    15,    16,    17,
       0,     0,     0,    20,    21,    22,     0,     0,     0,     0,
      26,    85,     0,     0,     0,    86,     0,    29,    87,    30,
      88,     0,    89,     0,    31,     0,     0,     0,     0,     0,
      91,     0,    32,     0,     0,     0,     0,     0,    92,     0,
      93,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      94,     0,    95,     0,     0,    97,    98,   621,     7,     8,
       0,     0,     0,     0,    34,    35,   101,     0,   102,     0,
       0,     0,     0,     0,   515,   106,     0,     0,     0,    40,
      82,    11,    12,     0,    13,     0,     0,     0,     0,    14,
      15,    16,    17,     0,     0,     0,    20,    21,    22,    23,
       0,     0,     0,    26,    85,     0,     0,     0,    86,     0,
      29,    87,    30,    88,     0,    89,     0,    31,     0,     0,
       0,     0,     0,    91,     0,    32,     0,     0,     0,     0,
       0,    92,     0,    93,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    94,     0,    95,     0,     0,    97,    98,
       0,     0,   100,     7,     8,     0,     0,    34,    35,   101,
       0,   102,     0,     0,     0,     0,   159,     0,   106,     0,
       0,     0,    40,     0,     0,    82,    11,    12,     0,    83,
       0,     0,     0,     0,    14,    15,    16,    17,     0,     0,
       0,    20,    21,    22,     0,     0,     0,     0,    26,    85,
       0,     0,     0,    86,     0,    29,    87,    30,    88,     0,
      89,     0,    31,     0,     0,     0,     0,     0,    91,     0,
      32,     0,     0,     0,     0,     0,    92,     0,    93,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    94,     0,
      95,     0,     0,    97,    98,     7,     8,     0,     0,     0,
       0,     0,    34,    35,   101,     0,   102,     0,     0,     0,
       0,     0,     0,   106,     0,     0,     0,    40,    11,    12,
       0,    13,     0,     0,     0,     0,    14,    15,    16,    17,
       0,     0,     0,    20,    21,    22,     0,     0,     0,     0,
      26,     0,     0,     0,     0,     0,     0,    29,     0,    30,
       0,     0,     0,     0,    31,     0,     0,     0,     0,     0,
     690,     0,    32,     0,    71,    72,    73,   691,    74,    75,
      76,    77,    78,   692,   693,   694,     0,     0,     0,     9,
      10,     0,    11,    12,     0,    83,     0,     0,     0,     0,
      14,    15,    16,    17,    34,    35,    19,    20,    21,     0,
      23,    24,    25,     0,    26,     0,    27,     0,     0,    40,
      28,    29,     0,    30,     0,     0,     0,    90,    31,     0,
       0,     0,     0,     0,    91,     0,    32,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   500,     0,
       0,     0,     0,     0,    94,     0,     0,     0,    96,     0,
     695,     0,   239,     0,     0,     0,     0,     0,   301,    35,
     696,     0,     0,   240,   265,   697,   242,   698,     0,   699,
     700,     0,     0,    40,    71,    72,    73,   501,    74,    75,
      76,    77,    78,   532,   502,    81,     0,     0,     0,     9,
      10,     0,    11,    12,     0,    83,     0,     0,     0,     0,
      14,    15,    16,    17,     0,     0,    19,    20,    21,     0,
      23,    24,    25,     0,    26,     0,    27,     0,     0,     0,
      28,    29,     0,    30,     0,     0,     0,    90,    31,     0,
       0,     0,     0,     0,     0,     0,    32,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    96,     0,
       0,     0,   239,     0,     0,     0,     0,     0,   301,    35,
       0,     0,     0,   240,   265,   503,   242,   504,     0,     0,
     533,     0,     0,    40,    71,    72,    73,     0,    74,    75,
      76,    77,    78,   532,   649,    81,     0,     0,     0,     9,
      10,     0,    11,    12,     0,    83,     0,     0,     0,     0,
      14,    15,    16,    17,     0,     0,    19,    20,    21,     0,
      23,    24,    25,     0,    26,     0,    27,     0,     0,     0,
      28,    29,     0,    30,     0,     0,     0,    90,    31,     0,
       0,     0,     0,     0,     0,     0,    32,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    96,     0,
     549,   550,   239,     0,     0,     0,     0,   551,   301,    35,
     552,   553,   554,   240,   265,   650,   242,   651,     0,     0,
     635,     0,     0,    40,   549,   550,   555,     0,   556,     0,
     557,   551,   558,     0,   552,   553,   554,     0,   559,   560,
      90,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     555,     0,   556,     0,   557,     0,   558,     0,     0,     0,
       0,     0,   559,   560,     0,     0,     0,     0,     0,     0,
       0,    96,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,   103,   104,
     169,     0,     0,     0,     0,   668,     0,   561,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,   103,   104,   169,     0,     0,     0,     0,     0,
       0,   669
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-440)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       3,     4,    22,     3,    86,    88,     4,    31,    29,    30,
     166,   174,   173,   180,    53,   146,   147,    85,     8,    87,
     143,    89,   101,    13,   173,     3,     4,   106,   174,     4,
       3,     4,    22,     3,     4,     3,     4,     4,     4,   141,
     366,    31,   348,     3,     4,    73,     7,   353,    40,   194,
     217,   393,   387,     4,   386,    45,   398,   386,    82,   348,
     499,   387,     3,     4,   353,   195,     7,   197,    76,   368,
     107,   499,   386,    88,   386,    76,   367,   368,    53,   292,
     368,    84,     3,    65,   364,    88,    84,   364,    88,   388,
     367,   368,    82,    83,    20,    85,    86,    87,    62,    89,
      90,   231,    63,   386,    19,   388,    84,    87,    18,    84,
      20,    84,   543,   332,    84,    66,    84,    84,    84,     1,
       4,    67,    63,     0,    84,   110,   111,   112,     1,    93,
     454,     8,    45,    84,    12,   120,   121,   265,   357,     0,
     143,    19,   466,    84,   275,   120,   118,   278,    18,    19,
      20,   120,   234,   143,   367,   368,    56,    39,    58,    41,
     129,   244,   293,    19,   118,    47,    39,   491,    41,    51,
     116,    71,   496,   301,    47,   175,    81,    39,    51,   120,
      85,    86,    97,   173,   174,    98,   317,   348,   619,    45,
     353,   194,   108,   118,   120,   121,   194,   113,   108,   112,
      84,   500,     8,   113,   179,   195,   125,   197,   127,   500,
     539,   543,   500,    20,   543,   190,   194,   118,   118,   194,
      76,   194,    78,   500,   194,   539,   194,   194,   194,   543,
     212,   543,   512,   378,   194,   512,   120,   119,   179,   206,
      19,   231,   257,   194,   234,   115,   119,   122,   123,   190,
     689,   288,   118,    19,   110,   111,   112,   265,    19,   435,
     543,   689,   438,     4,   265,   206,     7,   115,   116,   272,
      20,    19,   128,    81,   573,     0,   407,    85,    86,    45,
     109,   110,   272,   320,   321,    80,    81,   619,     0,    84,
     619,    86,    55,   301,   376,   630,   271,    82,    81,   291,
     301,   322,    85,    86,   630,   619,   612,   619,     0,    81,
     393,   331,    78,    85,    86,   398,    64,    65,    66,     0,
      68,   663,    63,   612,     6,   328,    88,   330,   328,    88,
     330,   120,   499,    80,    81,   484,    99,    84,   484,    86,
      83,   331,    90,    84,   110,   111,   112,   110,   111,   112,
     328,    81,   330,    82,    83,   328,    83,   330,   348,     8,
     328,   364,   330,   353,   364,   326,   364,   391,   328,   389,
     712,   120,   333,   101,   102,   378,   118,   355,   356,   120,
     378,   332,   527,   386,   106,   326,   376,   328,   386,   330,
     393,    81,   333,   393,   355,   398,    83,   686,   398,   389,
     378,   391,   120,   378,   432,   378,   357,   328,   378,   330,
     378,   378,   378,    92,   355,   418,   391,    12,   378,   110,
     111,   112,    55,    18,    19,    20,   556,   378,   418,     9,
      10,    11,   121,    13,    14,    15,    16,    17,   179,    81,
     391,   118,   383,    85,    86,   608,   609,    19,    20,   190,
      45,   612,    99,   100,   429,   318,   319,    93,   120,   120,
     609,   120,   608,   110,   111,   206,    99,   100,   104,   125,
     122,   118,   123,   109,   110,   111,   558,   110,   111,   112,
     124,   110,   111,   112,   607,   118,   119,   526,   429,   118,
      73,    74,    75,    80,   484,   110,   111,   112,   102,   601,
     476,   477,   478,    98,    81,   481,   121,    82,   120,   512,
     121,   667,   512,   108,   512,    82,   114,   112,   113,   120,
     599,     6,   689,   686,   527,   686,    64,    65,    66,   527,
      68,    82,   115,   116,   500,   115,   560,   109,   110,   111,
     543,   124,   621,   126,   127,   543,   110,   111,   112,   527,
     118,   526,   527,    81,   527,   579,    31,   527,   121,   527,
     527,   527,    31,   110,   111,   112,   556,   527,   558,   725,
     560,   120,   120,   641,   121,   115,   527,    95,    81,    97,
     663,   602,   664,    31,   102,   326,   717,   120,    53,   579,
     531,   121,   333,    12,   569,   109,   110,   111,   112,    18,
      19,    20,    19,   101,   579,   605,    64,    65,    66,   605,
      68,   110,   111,   112,   355,   133,   619,   607,   608,   609,
      55,   619,   612,   141,   565,    84,    45,   145,   330,   712,
     148,   579,   714,   109,   110,   111,   112,    27,    28,    36,
      30,   206,   539,   119,   217,    35,    36,    37,    38,   271,
     558,   641,    42,    43,    18,    19,    20,   178,    89,    49,
     663,   579,   619,   663,    99,   100,    56,   672,    58,   143,
     690,   143,   271,    63,   664,   110,   111,   112,   237,    98,
     418,    71,   720,   118,    18,    19,    20,   598,   429,   108,
      18,    19,    20,   112,   113,   576,   686,   109,   110,   111,
     690,    18,    19,    20,   682,    18,    19,    20,   413,   712,
     581,   335,   712,   103,   104,   609,     0,     1,    -1,    -1,
       4,     5,    -1,    -1,   714,     9,    10,    11,   118,    13,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      24,    25,    26,    27,    28,    -1,    30,    -1,    -1,    -1,
      -1,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      -1,    -1,    -1,    -1,    -1,    69,    -1,    71,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    91,    -1,    93,
      94,    95,     1,    97,    98,     4,     5,    -1,    -1,   103,
     104,   105,    -1,   107,    -1,   109,   110,   111,   112,    -1,
     114,   115,    -1,    -1,   118,    -1,    -1,    26,    27,    28,
      -1,    30,    -1,    -1,    -1,    -1,    35,    36,    37,    38,
      -1,    -1,    70,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    54,    -1,    56,    57,    58,
      59,    -1,    61,    -1,    63,    -1,    94,    95,    -1,    -1,
      69,    -1,    71,    -1,    -1,   103,   104,   105,    77,    -1,
      79,   109,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    91,    -1,    -1,    94,    95,     0,     1,    98,
      -1,     4,     5,    -1,   103,   104,   105,    -1,   107,    -1,
     109,   110,   111,   112,    -1,   114,    -1,    -1,    -1,   118,
     119,    -1,    -1,    26,    27,    28,    -1,    30,    -1,    -1,
      -1,    -1,    35,    36,    37,    38,    -1,    -1,    -1,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    54,    -1,    56,    57,    58,    59,    -1,    61,    -1,
      63,    -1,    -1,    -1,    -1,    -1,    69,    -1,    71,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    91,    -1,
      -1,    94,    95,     1,    -1,    98,     4,     5,    -1,    -1,
     103,   104,   105,    -1,   107,    -1,   109,   110,   111,   112,
      -1,   114,    -1,    -1,    -1,   118,    -1,    -1,    26,    27,
      28,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,    37,
      38,    -1,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    54,    -1,    56,    57,
      58,    59,    -1,    61,    -1,    63,    -1,    -1,    -1,    -1,
      -1,    69,    -1,    71,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    -1,    91,    -1,    -1,    94,    95,     0,     1,
      -1,    -1,     4,     5,    -1,   103,   104,   105,    -1,   107,
      -1,   109,   110,   111,   112,    -1,   114,    -1,    -1,    -1,
     118,   119,    24,    25,    -1,    27,    28,    -1,    30,    -1,
      -1,    -1,    -1,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    -1,    51,
      -1,    -1,    -1,    55,    56,    -1,    58,    -1,    -1,    -1,
      -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,     1,    -1,
      -1,     4,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   103,   104,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,    -1,    25,    -1,    27,    28,   118,    30,    -1,    -1,
      -1,    -1,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    -1,    51,    -1,
      -1,    -1,    55,    56,    -1,    58,    -1,    -1,    -1,    -1,
      63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,     4,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     103,   104,    -1,    -1,    -1,    -1,   109,   110,   111,    27,
      28,    -1,    30,    -1,    -1,   118,   119,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    -1,    51,    -1,    -1,    -1,    55,    56,    -1,
      58,    -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,    -1,     4,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   103,   104,    -1,    -1,    -1,
      -1,   109,   110,   111,    26,    27,    28,    -1,    30,    -1,
     118,   119,    -1,    35,    36,    37,    38,    -1,    -1,    -1,
      42,    43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    54,    -1,    56,    57,    58,    59,    -1,    61,
      -1,    63,    -1,    -1,    -1,    -1,    -1,    69,    -1,    71,
      72,    -1,    -1,    -1,    -1,    77,    -1,    79,     9,    10,
      11,    -1,    -1,    -1,    15,    16,    17,    89,    -1,    91,
      -1,    -1,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
      -1,   103,   104,   105,    -1,   107,    -1,   109,   110,   111,
     112,    -1,   114,    -1,    45,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,    -1,    -1,   115,   116,    -1,    -1,    -1,    -1,
     121,     4,     5,   124,    -1,    -1,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    24,    25,    26,    27,    28,    -1,    30,    -1,    -1,
      -1,    -1,    35,    36,    37,    38,    -1,    -1,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    -1,    -1,    -1,    -1,    -1,    69,    -1,    71,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    91,    -1,
      93,    94,    95,    -1,    97,    -1,    -1,    -1,    -1,    -1,
     103,   104,   105,    -1,   107,   108,   109,   110,   111,   112,
      -1,   114,   115,     4,     5,   118,    -1,    -1,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    24,    25,    26,    27,    28,    -1,    30,
      -1,    -1,    -1,    -1,    35,    36,    37,    38,    -1,    -1,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      71,    -1,    -1,    -1,    -1,    -1,    77,    -1,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      91,    -1,    93,    94,    95,    -1,    97,    -1,    -1,    -1,
      -1,    -1,   103,   104,   105,    -1,   107,   108,   109,   110,
     111,   112,    -1,   114,   115,     4,     5,   118,    -1,    -1,
       9,    10,    11,    -1,    13,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    24,    25,    26,    27,    28,
      -1,    30,    -1,    -1,    -1,    -1,    35,    36,    37,    38,
      -1,    -1,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    71,    -1,    -1,    -1,    -1,    -1,    77,    -1,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    91,    -1,    93,    94,    95,    -1,    97,    -1,
      -1,    -1,    -1,    -1,   103,   104,   105,    -1,   107,    -1,
     109,   110,   111,   112,    -1,   114,   115,     4,     5,   118,
      -1,    -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    -1,    -1,    -1,    24,    25,    26,
      27,    28,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,
      37,    38,    -1,    -1,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    -1,    -1,    -1,
      -1,    -1,    69,    -1,    71,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    91,    -1,    93,    94,    95,    -1,
      97,    -1,    -1,    -1,    -1,    -1,   103,   104,   105,    -1,
     107,   108,   109,   110,   111,   112,    -1,   114,   115,     4,
       5,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    -1,    -1,    -1,    24,
      25,    26,    27,    28,    -1,    30,    -1,    -1,    -1,    -1,
      35,    36,    37,    38,    -1,    -1,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    -1,
      -1,    -1,    -1,    -1,    69,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    77,    -1,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    91,    -1,    93,    94,
      95,    -1,    97,     4,     5,    -1,    -1,    -1,   103,   104,
     105,    -1,   107,   108,   109,   110,   111,   112,    -1,   114,
     115,    -1,    -1,   118,    -1,    26,    27,    28,    -1,    30,
      -1,    -1,    -1,    -1,    35,    36,    37,    38,    -1,    -1,
      -1,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    54,    -1,    56,    57,    58,    59,    -1,
      61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      71,    -1,    -1,    -1,    -1,    -1,    77,    -1,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      91,    -1,    -1,    94,    95,    -1,    -1,    98,     4,     5,
      -1,    -1,   103,   104,   105,    -1,   107,    -1,   109,   110,
     111,   112,    -1,   114,    -1,    -1,    -1,   118,    -1,    -1,
      26,    27,    28,    -1,    30,    -1,    -1,    -1,    -1,    35,
      36,    37,    38,    -1,    -1,    41,    42,    43,    44,    45,
      -1,    47,    -1,    49,    50,    51,    -1,    -1,    54,    -1,
      56,    57,    58,    59,    -1,    61,    -1,    63,    -1,    -1,
      -1,    -1,    -1,    69,    -1,    71,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    91,    -1,    -1,    94,    95,
      -1,    -1,    98,    -1,    -1,     4,     5,   103,   104,   105,
      -1,   107,    -1,    12,    -1,    -1,   112,    -1,   114,    18,
      19,    20,   118,    -1,    -1,    -1,    -1,    26,    27,    28,
      -1,    30,    -1,    -1,    -1,    -1,    35,    36,    37,    38,
      -1,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    54,    -1,    56,    57,    58,
      59,    -1,    61,    -1,    63,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    71,    -1,    -1,    -1,    -1,    -1,    77,    -1,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    91,    -1,    -1,    94,    95,    96,     4,     5,
      -1,    -1,    -1,    -1,   103,   104,   105,    -1,   107,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,    -1,    -1,   118,
      26,    27,    28,    -1,    30,    -1,    -1,    -1,    -1,    35,
      36,    37,    38,    -1,    -1,    -1,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    54,    -1,
      56,    57,    58,    59,    -1,    61,    -1,    63,    -1,    -1,
      -1,    -1,    -1,    69,    -1,    71,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    91,    -1,    -1,    94,    95,
      -1,    -1,    98,     4,     5,    -1,    -1,   103,   104,   105,
      -1,   107,    -1,    -1,    -1,    -1,   112,    -1,   114,    -1,
      -1,    -1,   118,    -1,    -1,    26,    27,    28,    -1,    30,
      -1,    -1,    -1,    -1,    35,    36,    37,    38,    -1,    -1,
      -1,    42,    43,    44,    -1,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    54,    -1,    56,    57,    58,    59,    -1,
      61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      71,    -1,    -1,    -1,    -1,    -1,    77,    -1,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      91,    -1,    -1,    94,    95,     4,     5,    -1,    -1,    -1,
      -1,    -1,   103,   104,   105,    -1,   107,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,    -1,    -1,   118,    27,    28,
      -1,    30,    -1,    -1,    -1,    -1,    35,    36,    37,    38,
      -1,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    58,
      -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    -1,
       5,    -1,    71,    -1,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    24,
      25,    -1,    27,    28,    -1,    30,    -1,    -1,    -1,    -1,
      35,    36,    37,    38,   103,   104,    41,    42,    43,    -1,
      45,    46,    47,    -1,    49,    -1,    51,    -1,    -1,   118,
      55,    56,    -1,    58,    -1,    -1,    -1,    62,    63,    -1,
      -1,    -1,    -1,    -1,    69,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    93,    -1,
      95,    -1,    97,    -1,    -1,    -1,    -1,    -1,   103,   104,
     105,    -1,    -1,   108,   109,   110,   111,   112,    -1,   114,
     115,    -1,    -1,   118,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    24,
      25,    -1,    27,    28,    -1,    30,    -1,    -1,    -1,    -1,
      35,    36,    37,    38,    -1,    -1,    41,    42,    43,    -1,
      45,    46,    47,    -1,    49,    -1,    51,    -1,    -1,    -1,
      55,    56,    -1,    58,    -1,    -1,    -1,    62,    63,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    97,    -1,    -1,    -1,    -1,    -1,   103,   104,
      -1,    -1,    -1,   108,   109,   110,   111,   112,    -1,    -1,
     115,    -1,    -1,   118,     9,    10,    11,    -1,    13,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    24,
      25,    -1,    27,    28,    -1,    30,    -1,    -1,    -1,    -1,
      35,    36,    37,    38,    -1,    -1,    41,    42,    43,    -1,
      45,    46,    47,    -1,    49,    -1,    51,    -1,    -1,    -1,
      55,    56,    -1,    58,    -1,    -1,    -1,    62,    63,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      22,    23,    97,    -1,    -1,    -1,    -1,    29,   103,   104,
      32,    33,    34,   108,   109,   110,   111,   112,    -1,    -1,
     115,    -1,    -1,   118,    22,    23,    48,    -1,    50,    -1,
      52,    29,    54,    -1,    32,    33,    34,    -1,    60,    61,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    -1,    50,    -1,    52,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,    -1,    -1,    -1,    -1,    93,    -1,   119,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,   119
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    87,   131,   133,   132,     0,     1,     4,     5,    24,
      25,    27,    28,    30,    35,    36,    37,    38,    40,    41,
      42,    43,    44,    45,    46,    47,    49,    51,    55,    56,
      58,    63,    71,    88,   103,   104,   109,   110,   111,   112,
     118,   134,   135,   137,   141,   145,   146,   153,   156,   159,
     165,   166,   167,   169,   173,   179,   180,   181,   188,   190,
     191,   212,   214,   215,   216,   217,   218,   222,   306,   308,
       1,     9,    10,    11,    13,    14,    15,    16,    17,    18,
      19,    20,    26,    30,    40,    50,    54,    57,    59,    61,
      62,    69,    77,    79,    89,    91,    93,    94,    95,    97,
      98,   105,   107,   110,   111,   112,   114,   115,   136,   139,
     141,   142,   147,   148,   153,   156,   159,   165,   171,   174,
     175,   176,   177,   178,   182,   183,   188,   224,   235,   237,
     238,   242,   243,   244,   249,   250,   251,   253,   255,   256,
     262,   263,   264,   269,   276,   283,   285,   286,   287,   288,
     289,   296,   297,   298,   299,   300,   301,   306,   308,   112,
     174,   182,   188,   308,   112,   136,   239,   118,   118,   112,
     136,   240,   239,   309,   307,   118,   173,   173,   240,   172,
      81,    85,    86,   192,   198,   199,   201,   203,   204,   201,
     172,    39,   144,   112,   120,   121,   136,   195,   196,   197,
     225,   118,     1,   119,   139,   146,   170,     8,   219,   174,
     191,   183,   186,    19,    19,   267,   267,    81,    85,    86,
     192,   193,   204,   205,   206,    20,    20,   240,   118,   142,
     195,   232,   233,   196,   236,   195,   234,    12,    19,    97,
     108,   110,   111,   112,   115,   138,   140,   141,   148,   153,
     156,   159,   165,   178,   182,   183,   188,   241,   273,   301,
     306,   308,   234,    93,   104,   109,   136,   184,   185,   209,
     211,   245,   282,    19,   271,   272,   273,   274,   272,   272,
     122,   123,   259,   260,   261,   259,   272,   259,   115,   298,
     139,   175,    82,   272,   252,   271,   272,   304,    10,    11,
      70,   103,   112,   115,   116,   121,   124,   209,   248,   256,
     257,   266,   268,   308,   272,   252,   252,   272,   115,   116,
     125,   127,     6,    19,    20,   139,   303,    88,   154,    88,
     157,   120,   213,   223,    55,    99,   100,   112,   118,   136,
     310,   311,   313,   314,   315,   316,   318,   321,   322,   323,
      99,   311,   313,   322,   137,   160,   162,   213,     1,    72,
     175,    85,   200,   203,   207,   208,    81,    83,    83,   119,
     118,   112,   139,   147,   308,   225,   121,   225,   120,   106,
     148,   168,   177,   220,     8,   191,   207,    81,    83,   120,
      92,   152,   225,   120,   196,   227,   228,   229,   120,   275,
     275,   301,   273,   120,   205,   118,    70,    94,   104,   139,
     212,   246,   247,   264,    19,    76,    78,   112,   128,   136,
     277,   279,   281,   308,   252,   125,   252,   122,   123,   172,
     288,   252,   115,   253,   254,    64,    65,    66,    68,   291,
     124,   305,   205,   252,   297,   297,   298,   298,   173,   174,
       1,   111,   119,   137,   155,   156,   159,   164,   165,   188,
     306,   308,     1,   111,   119,   137,   158,   159,   164,   188,
     306,   308,   239,   186,   174,   324,    80,    81,    84,    86,
     319,    80,   319,   320,   317,   312,   101,   102,   314,   321,
     323,   161,   165,   174,     1,   119,   163,   165,   186,    81,
      83,    12,    19,   110,   112,   115,   140,   253,   299,   308,
      82,    85,   198,   202,   108,   113,   194,   270,   274,   288,
     299,   108,   194,   270,   288,   299,   143,   120,   196,   147,
     188,   221,    18,   115,   138,   189,   190,   210,   211,   215,
     248,   253,   300,   198,   202,   108,   194,   300,   239,    22,
      23,    29,    32,    33,    34,    48,    50,    52,    54,    60,
      61,   119,   136,   139,   149,   150,   151,   183,   226,   230,
     231,   240,   241,    82,   241,   121,   120,   295,   303,   187,
     252,   304,   279,    73,    74,    75,   115,   116,   124,   126,
     127,   278,   280,    19,    97,   267,   263,   263,   290,   120,
     129,   258,     6,   144,   144,   118,   320,   320,   320,   320,
     119,   313,   322,   323,   325,    82,   144,   144,    85,   200,
     208,    96,   178,   194,   265,   270,   299,    18,    19,    20,
      81,    12,    19,   110,   112,   115,   140,   253,   299,   308,
      31,   121,   119,   139,   146,   147,   188,    20,   189,    19,
     110,   112,   210,   300,   302,   308,    31,   225,   227,   240,
     188,   112,   139,   120,   108,   194,   295,   115,    93,   119,
     151,   231,   305,    19,    90,   291,   292,   293,   294,   259,
     271,   173,   162,   209,   313,   311,   322,   325,   323,    81,
       5,    12,    18,    19,    20,    95,   105,   110,   112,   114,
     115,   210,   244,   253,   308,    31,   259,   202,    18,    19,
      20,   195,   120,   241,   121,   196,   303,   258,    67,   116,
     121,    53,   284,   119,   208,   239,    18,    19,    20,   241,
     196,   252,   294,   303
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, parser, retval, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, parser)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, parser, retval); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, parser, retval)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    Lily_parser *parser;
    SCM *retval;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, parser, retval)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    Lily_parser *parser;
    SCM *retval;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, parser, retval);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, Lily_parser *parser, SCM *retval)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, parser, retval)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    Lily_parser *parser;
    SCM *retval;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , parser, retval);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, parser, retval); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, Lily_parser *parser, SCM *retval)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, parser, retval)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    Lily_parser *parser;
    SCM *retval;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (Lily_parser *parser, SCM *retval)
#else
int
yyparse (parser, retval)
    Lily_parser *parser;
    SCM *retval;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc = yyloc_default;


    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
/* Line 1792 of yacc.c  */
#line 372 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);
	}
    break;

  case 4:
/* Line 1792 of yacc.c  */
#line 375 "parser.yy"
    {
		parser->lexer_->pop_state ();
                *retval = (yyvsp[(3) - (3)]);
 	}
    break;

  case 5:
/* Line 1792 of yacc.c  */
#line 381 "parser.yy"
    { (yyval) = SCM_UNSPECIFIED; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 382 "parser.yy"
    {
	}
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 384 "parser.yy"
    {
	}
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 386 "parser.yy"
    {
		parser->error_level_ = 1;
	}
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 389 "parser.yy"
    {
		parser->error_level_ = 1;
	}
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 396 "parser.yy"
    {
		parser->lexer_->add_scope (get_header (parser));
	}
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 398 "parser.yy"
    {
		parser->lexer_->set_identifier (ly_symbol2scm ("$defaultheader"), (yyvsp[(2) - (2)]));
	}
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 401 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-book-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 405 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-bookpart-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 409 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier
			(unsmob_book((yyvsp[(1) - (1)]))->paper_
			 ? "toplevel-book-handler"
			 : "toplevel-bookpart-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 416 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 420 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-music-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 424 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_2 (proc, parser->self_scm (), scm_list_1 ((yyvsp[(1) - (1)])));
	}
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 428 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 432 "parser.yy"
    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token ((yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
	}
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 437 "parser.yy"
    {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup ((yyvsp[(1) - (1)])))
			out = scm_list_1 ((yyvsp[(1) - (1)]));
		else if (Text_interface::is_markup_list ((yyvsp[(1) - (1)])))
			out = (yyvsp[(1) - (1)]);
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
			scm_call_2 (proc, parser->self_scm (), out);
		} else if (unsmob_score ((yyvsp[(1) - (1)])))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
			scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
		} else if (!scm_is_eq ((yyvsp[(1) - (1)]), SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[(1) - (1)]), _("bad expression type"));
	}
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 454 "parser.yy"
    {
		SCM id = SCM_EOL;
		Output_def * od = unsmob_output_def ((yyvsp[(1) - (1)]));

		if (od->c_variable ("is-paper") == SCM_BOOL_T)
			id = ly_symbol2scm ("$defaultpaper");
		else if (od->c_variable ("is-midi") == SCM_BOOL_T)
			id = ly_symbol2scm ("$defaultmidi");
		else if (od->c_variable ("is-layout") == SCM_BOOL_T)
			id = ly_symbol2scm ("$defaultlayout");

		parser->lexer_->set_identifier (id, (yyvsp[(1) - (1)]));
	}
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 471 "parser.yy"
    {
		(yyval) = parser->lexer_->eval_scm_token ((yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
	}
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 485 "parser.yy"
    {
		(yyval) = parser->lexer_->eval_scm_token ((yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
	}
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 521 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("music-function", (yyloc),
					 (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 529 "parser.yy"
    {
		// FIXME: @$ does not contain a useful source location
		// for empty rules, and the only token in the whole
		// production, EMBEDDED_LILY, is synthetic and also
		// contains no source location.
		(yyval) = MAKE_SYNTAX ("void-music", (yyloc));
	}
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 537 "parser.yy"
    {
		(yyvsp[(3) - (3)]) = scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL);
		if (unsmob_music ((yyvsp[(2) - (3)])))
			(yyvsp[(3) - (3)]) = scm_cons ((yyvsp[(2) - (3)]), (yyvsp[(3) - (3)]));
		if (unsmob_music ((yyvsp[(1) - (3)])))
			(yyvsp[(3) - (3)]) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
		(yyval) = MAKE_SYNTAX ("sequential-music", (yyloc), (yyvsp[(3) - (3)]));
	}
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 545 "parser.yy"
    {
		parser->error_level_ = 1;
                (yyval) = SCM_UNSPECIFIED;
	}
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 549 "parser.yy"
    {
		parser->error_level_ = 1;
                (yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 557 "parser.yy"
    { (yyval) = SCM_UNSPECIFIED; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 558 "parser.yy"
    {

	}
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 561 "parser.yy"
    {

	}
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 567 "parser.yy"
    {
		(yyval) = parser->lexer_->remove_scope ();
	}
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 576 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 580 "parser.yy"
    {
	        parser->lexer_->set_identifier ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
                (yyval) = SCM_UNSPECIFIED;
	}
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 584 "parser.yy"
    {
		SCM path = scm_cons (scm_string_to_symbol ((yyvsp[(1) - (4)])), (yyvsp[(2) - (4)]));
		parser->lexer_->set_identifier (path, (yyvsp[(4) - (4)]));
                (yyval) = SCM_UNSPECIFIED;
	}
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 589 "parser.yy"
    {
		SCM path = scm_cons (scm_string_to_symbol ((yyvsp[(1) - (5)])), (yyvsp[(3) - (5)]));
		parser->lexer_->set_identifier (path, (yyvsp[(5) - (5)]));
                (yyval) = SCM_UNSPECIFIED;
	}
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 605 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL);
		if (Music *m = unsmob_music ((yyvsp[(1) - (2)])))
		{
			if (m->is_mus_type ("post-event-wrapper"))
				(yyval) = scm_append
					(scm_list_2 (m->get_property ("elements"),
						     (yyval)));
			else
				(yyval) = scm_cons ((yyvsp[(1) - (2)]), (yyval));
		}
		if (scm_is_pair ((yyval))
		    && scm_is_null (scm_cdr ((yyval))))
			(yyval) = scm_car ((yyval));
		else
		{
			Music * m = MY_MAKE_MUSIC ("PostEvents", (yyloc));
			m->set_property ("elements", (yyval));
			(yyval) = m->unprotect ();
		}
	}
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 636 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		unsmob_context_def ((yyval))->origin ()->set_spot ((yyloc));
	}
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 645 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);
	}
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 650 "parser.yy"
    {
		parser->lexer_->pop_state ();
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 658 "parser.yy"
    {
		if (unsmob_music ((yyvsp[(1) - (1)]))) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			(yyvsp[(1) - (1)]) = scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
		}
		if (unsmob_context_mod ((yyvsp[(1) - (1)])))
			(yyval) = (yyvsp[(1) - (1)]);
		else {
			parser->parser_error ((yylsp[(1) - (1)]), _ ("not a context mod"));
			(yyval) = Context_mod ().smobbed_copy ();
		}
	}
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 674 "parser.yy"
    {
		(yyval) = Context_def::make_scm ();
	}
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 677 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 680 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(2) - (2)])))
			unsmob_context_def ((yyval))->add_context_mod ((yyvsp[(2) - (2)]));
	}
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 684 "parser.yy"
    {
                Context_def *td = unsmob_context_def ((yyval));
                SCM new_mods = unsmob_context_mod ((yyvsp[(2) - (2)]))->get_mods ();
                for (SCM m = new_mods; scm_is_pair (m); m = scm_cdr (m)) {
                    td->add_context_mod (scm_car (m));
                }
	}
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 691 "parser.yy"
    {
                Context_def *td = unsmob_context_def ((yyval));
                SCM new_mods = unsmob_context_mod ((yyvsp[(2) - (2)]))->get_mods ();
                for (SCM m = new_mods; scm_is_pair (m); m = scm_cdr (m)) {
                    td->add_context_mod (scm_car (m));
                }
	}
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 703 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		unsmob_book ((yyval))->origin ()->set_spot ((yyloc));
		pop_paper (parser);
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), SCM_BOOL_F);
	}
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 715 "parser.yy"
    {
		Book *book = new Book;
		init_papers (parser);
		book->paper_ = dynamic_cast<Output_def*> (unsmob_output_def (parser->lexer_->lookup_identifier ("$defaultpaper"))->clone ());
		book->paper_->unprotect ();
		push_paper (parser, book->paper_);
		book->header_ = get_header (parser);
                (yyval) = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), (yyval));
	}
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 725 "parser.yy"
    {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), (yyvsp[(1) - (1)]));
	}
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 728 "parser.yy"
    {
		unsmob_book ((yyvsp[(1) - (2)]))->paper_ = unsmob_output_def ((yyvsp[(2) - (2)]));
		set_paper (parser, unsmob_output_def ((yyvsp[(2) - (2)])));
	}
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 732 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("book-bookpart-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 736 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 740 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("book-music-handler");
		scm_call_3 (proc, parser->self_scm (), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 744 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), scm_list_1 ((yyvsp[(2) - (2)])));
	}
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 748 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 752 "parser.yy"
    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token ((yyvsp[(2) - (2)]), (yylsp[(2) - (2)]));
	}
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 757 "parser.yy"
    {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup ((yyvsp[(2) - (2)])))
			out = scm_list_1 ((yyvsp[(2) - (2)]));
		else if (Text_interface::is_markup_list ((yyvsp[(2) - (2)])))
			out = (yyvsp[(2) - (2)]);
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
			scm_call_2 (proc, (yyvsp[(1) - (2)]), out);
		} else if (unsmob_score ((yyvsp[(2) - (2)])))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
			scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
		} else if (!scm_is_eq ((yyvsp[(2) - (2)]), SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[(2) - (2)]), _("bad expression type"));
	}
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 775 "parser.yy"
    {
		parser->lexer_->add_scope (unsmob_book ((yyvsp[(1) - (1)]))->header_);
	}
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 778 "parser.yy"
    {
                Book *book = unsmob_book ((yyvsp[(1) - (2)]));
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
		book->bookparts_ = SCM_EOL;
	}
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 787 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		unsmob_book ((yyval))->origin ()->set_spot ((yyloc));
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), SCM_BOOL_F);
	}
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 795 "parser.yy"
    {
		Book *book = new Book;
                (yyval) = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), (yyval));
	}
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 800 "parser.yy"
    {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), (yyvsp[(1) - (1)]));
	}
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 803 "parser.yy"
    {
		unsmob_book ((yyval))->paper_ = unsmob_output_def ((yyvsp[(2) - (2)]));
	}
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 806 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 810 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-music-handler");
		scm_call_3 (proc, parser->self_scm (), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 814 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), scm_list_1 ((yyvsp[(2) - (2)])));
	}
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 818 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 822 "parser.yy"
    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token ((yyvsp[(2) - (2)]), (yylsp[(2) - (2)]));
	}
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 827 "parser.yy"
    {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup ((yyvsp[(2) - (2)])))
			out = scm_list_1 ((yyvsp[(2) - (2)]));
		else if (Text_interface::is_markup_list ((yyvsp[(2) - (2)])))
			out = (yyvsp[(2) - (2)]);
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
			scm_call_2 (proc, (yyvsp[(1) - (2)]), out);
		} else if (unsmob_score ((yyvsp[(2) - (2)])))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
			scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
		} else if (!scm_is_eq ((yyvsp[(2) - (2)]), SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[(2) - (2)]), _("bad expression type"));
	}
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 845 "parser.yy"
    {
                Book *book = unsmob_book ((yyvsp[(1) - (1)]));
		if (!ly_is_module (book->header_))
			book->header_ = ly_make_module (false);
		parser->lexer_->add_scope (book->header_);
	}
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 851 "parser.yy"
    {
                Book *book = unsmob_book ((yyvsp[(1) - (2)]));
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
	}
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 859 "parser.yy"
    {
		unsmob_score ((yyvsp[(3) - (4)]))->origin ()->set_spot ((yyloc));
		(yyval) = (yyvsp[(3) - (4)]);
	}
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 867 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 871 "parser.yy"
    {
		if (!scm_is_pair ((yyvsp[(1) - (1)]))
		    || !ly_is_module (scm_car ((yyvsp[(1) - (1)]))))
			(yyvsp[(1) - (1)]) = scm_cons (ly_make_module (false), (yyvsp[(1) - (1)]));
		parser->lexer_->add_scope (scm_car ((yyvsp[(1) - (1)])));
	}
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 877 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (3)]);
	}
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 881 "parser.yy"
    {
                Output_def *od = unsmob_output_def ((yyvsp[(2) - (2)]));
		if (od->lookup_variable (ly_symbol2scm ("is-paper")) == SCM_BOOL_T)
		{
			parser->parser_error ((yylsp[(2) - (2)]), _("\\paper cannot be used in \\score, use \\layout instead"));

		}
		else
		{
			if (scm_is_pair ((yyvsp[(1) - (2)])) && ly_is_module (scm_car ((yyvsp[(1) - (2)]))))
				scm_set_cdr_x ((yyvsp[(1) - (2)]), scm_cons ((yyvsp[(2) - (2)]), scm_cdr ((yyvsp[(1) - (2)]))));
			else
				(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
		}
	}
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 901 "parser.yy"
    {
		SCM scorify = ly_lily_module_constant ("scorify-music");
		(yyval) = scm_call_2 (scorify, (yyvsp[(2) - (2)]), parser->self_scm ());

		if (scm_is_pair ((yyvsp[(1) - (2)])) && ly_is_module (scm_car ((yyvsp[(1) - (2)]))))
		{
			unsmob_score ((yyval))->set_header (scm_car ((yyvsp[(1) - (2)])));
			(yyvsp[(1) - (2)]) = scm_cdr ((yyvsp[(1) - (2)]));
		}
		for (SCM p = scm_reverse_x ((yyvsp[(1) - (2)]), SCM_EOL);
		     scm_is_pair (p); p = scm_cdr (p))
		{
			unsmob_score ((yyval))->
				add_output_def (unsmob_output_def (scm_car (p)));
		}
	}
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 917 "parser.yy"
    {
		if (!unsmob_score ((yyvsp[(1) - (1)])))
		{
			(yyval) = (new Score)->unprotect ();
			parser->parser_error ((yylsp[(1) - (1)]), _("score expected"));
		}
	}
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 925 "parser.yy"
    {
                Score *score = unsmob_score ((yyvsp[(1) - (1)]));
		if (!ly_is_module (score->get_header ()))
			score->set_header (ly_make_module (false));
		parser->lexer_->add_scope (score->get_header ());
	}
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 931 "parser.yy"
    {
                Output_def *od = unsmob_output_def ((yyvsp[(2) - (2)]));
		if (od->lookup_variable (ly_symbol2scm ("is-paper")) == SCM_BOOL_T)
		{
			parser->parser_error ((yylsp[(2) - (2)]), _("\\paper cannot be used in \\score, use \\layout instead"));

		}
		else
		{
			unsmob_score ((yyvsp[(1) - (2)]))->add_output_def (od);
		}
	}
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 943 "parser.yy"
    {
		unsmob_score ((yyval))->error_found_ = true;
	}
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 954 "parser.yy"
    {
                Output_def *od = unsmob_output_def ((yyvsp[(1) - (1)]));

		if (od->lookup_variable (ly_symbol2scm ("is-paper")) != SCM_BOOL_T)
		{
			parser->parser_error ((yylsp[(1) - (1)]), _ ("need \\paper for paper block"));
			(yyval) = get_paper (parser)->unprotect ();
		}
	}
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 967 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (2)]);

		parser->lexer_->remove_scope ();
		parser->lexer_->pop_state ();
	}
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 976 "parser.yy"
    {
                Output_def *p = get_paper (parser);
		p->input_origin_ = (yyloc);
		parser->lexer_->add_scope (p->scope_);
                (yyval) = p->unprotect ();
	}
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 982 "parser.yy"
    {
		Output_def *p = get_midi (parser);
		(yyval) = p->unprotect ();
		parser->lexer_->add_scope (p->scope_);
	}
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 987 "parser.yy"
    {
		Output_def *p = get_layout (parser);

		parser->lexer_->add_scope (p->scope_);
		(yyval) = p->unprotect ();
	}
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 996 "parser.yy"
    {
		parser->lexer_->push_initial_state ();
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1013 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (2)]);
		unsmob_output_def ((yyval))->input_origin_.set_spot ((yyloc));
	}
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1017 "parser.yy"
    {
		Output_def *o = unsmob_output_def ((yyvsp[(3) - (3)]));
		o->input_origin_.set_spot ((yyloc));
		(yyval) = o->self_scm ();
		parser->lexer_->remove_scope ();
		parser->lexer_->add_scope (o->scope_);
	}
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1024 "parser.yy"
    {

	}
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1027 "parser.yy"
    {

	}
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1031 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);
	}
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1035 "parser.yy"
    {
		parser->lexer_->pop_state ();
		if (unsmob_context_def ((yyvsp[(3) - (3)])))
			assign_context_def (unsmob_output_def ((yyvsp[(1) - (3)])), (yyvsp[(3) - (3)]));
		else {

			SCM proc = parser->lexer_->lookup_identifier
				     ("output-def-music-handler");
			scm_call_3 (proc, parser->self_scm (),
				    (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
		}
	}
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1047 "parser.yy"
    {

	}
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1053 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("tempo", (yyloc), SCM_EOL, (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
	}
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1056 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("tempo", (yyloc), (yyvsp[(2) - (5)]), (yyvsp[(3) - (5)]), (yyvsp[(5) - (5)]));
	}
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1059 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("tempo", (yyloc), (yyvsp[(2) - (2)]));
	}
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1068 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1071 "parser.yy"
    {
		if (unsmob_music ((yyvsp[(2) - (2)])))
			(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1075 "parser.yy"
    {
		Music *m = MY_MAKE_MUSIC("Music", (yyloc));
		// ugh. code dup
		m->set_property ("error-found", SCM_BOOL_T);
		(yyval) = scm_cons (m->self_scm (), (yyvsp[(1) - (2)]));
		m->unprotect (); /* UGH */
	}
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1086 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(2) - (3)]), SCM_EOL);
	}
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1097 "parser.yy"
    {
		if (unsmob_music ((yyvsp[(1) - (1)]))->is_mus_type ("post-event")) {
			parser->parser_error ((yylsp[(1) - (1)]), _ ("unexpected post-event"));
			(yyval) = SCM_UNSPECIFIED;
		}
	}
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 1104 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1108 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (3)]);
	}
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1115 "parser.yy"
    {
		if (scm_is_eq ((yyvsp[(1) - (1)]), SCM_UNSPECIFIED))
			(yyval) = (yyvsp[(1) - (1)]);
		else if (Music *m = unsmob_music ((yyvsp[(1) - (1)]))) {
			if (m->is_mus_type ("post-event")) {
				parser->parser_error
					((yylsp[(1) - (1)]), _ ("unexpected post-event"));
				(yyval) = SCM_UNSPECIFIED;
			} else
				(yyval) = (yyvsp[(1) - (1)]);
		} else if (parser->lexer_->is_lyric_state ()
			   && Text_interface::is_markup ((yyvsp[(1) - (1)])))
			MYBACKUP (LYRIC_ELEMENT, (yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
		else {
			(yyloc).warning (_ ("Ignoring non-music expression"));
			(yyval) = (yyvsp[(1) - (1)]);
		}
	}
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1137 "parser.yy"
    {
	        (yyval) = make_music_from_simple (parser, (yylsp[(1) - (1)]), (yyvsp[(1) - (1)]));
                if (!unsmob_music ((yyval)))
		{
                        parser->parser_error ((yylsp[(1) - (1)]), _ ("music expected"));
			(yyval) = MAKE_SYNTAX ("void-music", (yyloc));
		}
	}
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1155 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("repeat", (yyloc), (yyvsp[(2) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(4) - (4)]), SCM_EOL);
	}
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 1159 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("repeat", (yyloc), scm_car ((yyvsp[(1) - (2)])), scm_cdr ((yyvsp[(1) - (2)])),
				  (yyvsp[(2) - (2)]), SCM_EOL);
	}
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1164 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("repeat", (yyloc), (yyvsp[(2) - (6)]), (yyvsp[(3) - (6)]), (yyvsp[(4) - (6)]), (yyvsp[(6) - (6)]));
	}
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1168 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("repeat", (yyloc), scm_car ((yyvsp[(1) - (4)])), scm_cdr ((yyvsp[(1) - (4)])),
				  (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
	}
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1175 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("sequential-music", (yyloc), (yyvsp[(2) - (2)]));
	}
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1178 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("sequential-music", (yyloc), (yyvsp[(1) - (1)]));
	}
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1184 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("simultaneous-music", (yyloc), (yyvsp[(2) - (2)]));
	}
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1187 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("simultaneous-music", (yyloc), scm_reverse_x ((yyvsp[(2) - (3)]), SCM_EOL));
	}
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 1200 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);
	}
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1204 "parser.yy"
    {
                parser->lexer_->pop_state ();
                (yyval) = (yyvsp[(4) - (5)]);
        }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1209 "parser.yy"
    {
                (yyval) = (yyvsp[(2) - (2)]);
        }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1213 "parser.yy"
    {
                (yyval) = (yyvsp[(1) - (1)]);
        }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1217 "parser.yy"
    {
		if (unsmob_music ((yyvsp[(2) - (2)]))) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			(yyvsp[(2) - (2)]) = scm_call_2 (proc, parser->self_scm (), (yyvsp[(2) - (2)]));
		}
		if (unsmob_context_mod ((yyvsp[(2) - (2)])))
			(yyval) = (yyvsp[(2) - (2)]);
		else {
			parser->parser_error ((yylsp[(2) - (2)]), _ ("not a context mod"));
			(yyval) = Context_mod ().smobbed_copy ();
		}
	}
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1237 "parser.yy"
    {
            (yyval) = SCM_EOL;
        }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1241 "parser.yy"
    {
              (yyval) = (yyvsp[(1) - (1)]);
        }
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1247 "parser.yy"
    {
            (yyval) = Context_mod ().smobbed_copy ();
        }
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 1250 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(2) - (2)])))
			unsmob_context_mod ((yyvsp[(1) - (2)]))->add_context_mod ((yyvsp[(2) - (2)]));
        }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1254 "parser.yy"
    {
                 Context_mod *md = unsmob_context_mod ((yyvsp[(2) - (2)]));
                 if (md)
                     unsmob_context_mod ((yyvsp[(1) - (2)]))->add_context_mods (md->get_mods ());
        }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1259 "parser.yy"
    {
		unsmob_context_mod ((yyvsp[(1) - (2)]))->add_context_mods
			(unsmob_context_mod ((yyvsp[(2) - (2)]))->get_mods ());
        }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1274 "parser.yy"
    {
		(yyval) = FINISH_MAKE_SYNTAX ((yyvsp[(1) - (2)]), (yyloc), (yyvsp[(2) - (2)]));
	}
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1287 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1288 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1353 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1357 "parser.yy"
    {
		SCM n = scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (5)]), n)))
			(yyval) = scm_cons (n, (yyvsp[(3) - (5)]));
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[(5) - (5)]));
			t->set_property ("digit", (yyvsp[(5) - (5)]));
			(yyval) = check_scheme_arg (parser, (yylsp[(4) - (5)]), t->unprotect (),
					       (yyvsp[(3) - (5)]), (yyvsp[(2) - (5)]), n);
		}
		
	}
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1370 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (5)]),
				       scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED),
				       (yyvsp[(3) - (5)]), (yyvsp[(2) - (5)]));
	}
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 1376 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (5)]),
				       scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED),
				       (yyvsp[(3) - (5)]), (yyvsp[(2) - (5)]));
	}
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1387 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1391 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1395 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]),
				       try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)])),
				       (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
	}
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1401 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]),
				       try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)])),
				       (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
	}
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1407 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1415 "parser.yy"
    {
		(yyval) = scm_append (scm_list_2 ((yyvsp[(1) - (3)]), scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL)));
	}
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 1423 "parser.yy"
    {
		(yyval) = scm_append_x (scm_list_2 ((yyvsp[(3) - (3)]), (yyvsp[(1) - (3)])));
	}
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 1432 "parser.yy"
    {
		SCM sym_l_p = ly_lily_module_constant ("symbol-list?");
		(yyval) = try_string_variants (sym_l_p, (yyvsp[(1) - (1)]));
		if (SCM_UNBNDP ((yyval))) {
			parser->parser_error ((yylsp[(1) - (1)]), _("not a symbol"));
			(yyval) = SCM_EOL;
		} else
			(yyval) = scm_reverse ((yyval));
	}
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1454 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
			(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
		else
			(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]),
					       make_music_from_simple
					       (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)])),
					       (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1464 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1468 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1472 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1476 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1480 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1484 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1491 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		SCM res = try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(2) - (4)]), make_music_from_simple
			   (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)])))))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), STRING, (yyvsp[(4) - (4)]));
		else
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, (yyvsp[(4) - (4)]));
	}
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1508 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		SCM res = try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(2) - (4)]), make_music_from_simple
			   (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)])))))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), STRING, (yyvsp[(4) - (4)]));
		else
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, (yyvsp[(4) - (4)]));
	}
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1525 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, (yyvsp[(4) - (4)]));
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(2) - (4)]), make_music_from_simple
			   (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)])))))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), STRING, (yyvsp[(4) - (4)]));
		else
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, (yyvsp[(4) - (4)]));
	}
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1538 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), REAL, (yyvsp[(4) - (4)]));
		else {
			SCM d = make_duration ((yyvsp[(4) - (4)]));
			if (SCM_UNBNDP (d) || scm_is_false (scm_call_1 ((yyvsp[(2) - (4)]), d)))
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), REAL, (yyvsp[(4) - (4)])); // trigger error
			else
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), DURATION_IDENTIFIER, d);
		}
	}
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1550 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), DURATION_IDENTIFIER, (yyvsp[(4) - (4)]));
	}
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1565 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (SCM_ARG, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1575 "parser.yy"
    {
		(yyvsp[(4) - (6)]) = MAKE_SYNTAX ("repeat", (yylsp[(4) - (6)]), (yyvsp[(5) - (6)]), (yyvsp[(6) - (6)]),
				  MY_MAKE_MUSIC ("Music", (yylsp[(4) - (6)]))->unprotect (),
				  SCM_EOL);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (6)]), (yyvsp[(4) - (6)]))))
		{
			(yyval) = (yyvsp[(3) - (6)]);
			MYREPARSE ((yylsp[(4) - (6)]), (yyvsp[(2) - (6)]), REPEAT_IDENTIFIER, scm_cons ((yyvsp[(5) - (6)]), (yyvsp[(6) - (6)])));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (6)]), (yyvsp[(1) - (6)])), (yyvsp[(3) - (6)]));
			MYBACKUP (REPEAT_IDENTIFIER, scm_cons ((yyvsp[(5) - (6)]), (yyvsp[(6) - (6)])), (yylsp[(4) - (6)]));
		}
	}
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1589 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = (yyvsp[(3) - (4)]);
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), CHORD_BODY_IDENTIFIER, (yyvsp[(4) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (CHORD_BODY_IDENTIFIER, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1600 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (EVENT_IDENTIFIER, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1610 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
			(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
		else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (LYRIC_ELEMENT, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1619 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), REAL, (yyvsp[(4) - (4)]));
			(yyval) = (yyvsp[(3) - (4)]);
		} else {
			SCM d = make_duration ((yyvsp[(4) - (4)]));
			if (SCM_UNBNDP (d) || scm_is_false (scm_call_1 ((yyvsp[(2) - (4)]), d)))
			{
				(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
				MYBACKUP (UNSIGNED, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
			} else {
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), DURATION_IDENTIFIER, d);
				(yyval) = (yyvsp[(3) - (4)]);
			}
		}
	}
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1637 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = (yyvsp[(3) - (4)]);
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), REAL, (yyvsp[(4) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (REAL, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1648 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (NUMBER_IDENTIFIER, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1658 "parser.yy"
    {
		SCM n = scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (5)]), n))) {
			(yyval) = (yyvsp[(3) - (5)]);
			MYREPARSE ((yylsp[(5) - (5)]), (yyvsp[(2) - (5)]), REAL, n);
		} else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[(5) - (5)]));
			t->set_property ("digit", (yyvsp[(5) - (5)]));
			(yyval) = t->unprotect ();
			if (scm_is_true (scm_call_1 ((yyvsp[(2) - (5)]), (yyval))))
				(yyval) = scm_cons ((yyval), (yyvsp[(3) - (5)]));
			else {
				(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (5)]), (yyvsp[(1) - (5)])), (yyvsp[(3) - (5)]));
				MYBACKUP (UNSIGNED, (yyvsp[(5) - (5)]), (yylsp[(5) - (5)]));
				parser->lexer_->push_extra_token ('-');
			}
		}
		
	}
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1678 "parser.yy"
    {
		SCM n = scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (5)]), n))) {
			MYREPARSE ((yylsp[(5) - (5)]), (yyvsp[(2) - (5)]), REAL, n);
			(yyval) = (yyvsp[(3) - (5)]);
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (5)]), (yyvsp[(1) - (5)])), (yyvsp[(3) - (5)]));
			MYBACKUP (REAL, n, (yylsp[(5) - (5)]));
		}
	}
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1689 "parser.yy"
    {
		SCM n = scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (5)]), n))) {
			(yyval) = scm_cons (n, (yyvsp[(3) - (5)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (5)]), (yyvsp[(1) - (5)])), (yyvsp[(3) - (5)]));
			MYBACKUP (NUMBER_IDENTIFIER, n, (yylsp[(5) - (5)]));
		}
	}
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1699 "parser.yy"
    {
		SCM m = make_music_from_simple (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]));
		if (unsmob_music (m) && scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), m)))
		{
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), PITCH_IDENTIFIER, (yyvsp[(4) - (4)]));
			(yyval) = (yyvsp[(3) - (4)]);
		} else if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), PITCH_ARG, (yyvsp[(4) - (4)]));
			(yyval) = (yyvsp[(3) - (4)]);
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (PITCH_IDENTIFIER, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1715 "parser.yy"
    {
		SCM m = make_music_from_simple (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]));
		if (unsmob_music (m) && scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), m)))
		{
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), NOTENAME_PITCH, (yyvsp[(4) - (4)]));
			(yyval) = (yyvsp[(3) - (4)]);
		} else if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), PITCH_ARG, (yyvsp[(4) - (4)]));
			(yyval) = (yyvsp[(3) - (4)]);
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (NOTENAME_PITCH, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1731 "parser.yy"
    {
		SCM m = make_music_from_simple (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]));
		if (unsmob_music (m) && scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), m)))
		{
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), TONICNAME_PITCH, (yyvsp[(4) - (4)]));
			(yyval) = (yyvsp[(3) - (4)]);
		} else if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), PITCH_ARG, (yyvsp[(4) - (4)]));
			(yyval) = (yyvsp[(3) - (4)]);
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (TONICNAME_PITCH, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1747 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), DURATION_IDENTIFIER, (yyvsp[(4) - (4)]));
			(yyval) = (yyvsp[(3) - (4)]);
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (DURATION_IDENTIFIER, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1758 "parser.yy"
    {
		SCM res = try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				(yyval) = (yyvsp[(3) - (4)]);
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SYMBOL_LIST, res);
			}
			else
				(yyval) = scm_cons (res, (yyvsp[(3) - (4)]));
		else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (SCM_IDENTIFIER, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1773 "parser.yy"
    {
		SCM res = try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				(yyval) = (yyvsp[(3) - (4)]);
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SYMBOL_LIST, res);
			}
			else
				(yyval) = scm_cons (res, (yyvsp[(3) - (4)]));
		else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (STRING, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1788 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (3)]), (yyvsp[(3) - (3)]))))
			(yyval) = scm_cons ((yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]));
		else
			(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
					       make_music_from_simple
					       (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)])),
					       (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1798 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1803 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1808 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1813 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1821 "parser.yy"
    {
		(yyval) = scm_cons (loc_on_music ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
	}
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1829 "parser.yy"
    {
		(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)])), (yyvsp[(3) - (3)]));
	}
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1835 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1839 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]))))
			(yyval) = scm_cons ((yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]));
		else
			(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
					       make_music_from_simple
					       (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)])),
					       (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1849 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1854 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1859 "parser.yy"
    {
		SCM n = scm_difference ((yyvsp[(4) - (4)]), SCM_UNDEFINED);
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), n, (yyvsp[(2) - (4)]), (yyvsp[(1) - (4)]));
	}
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1864 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1869 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1874 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1879 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1884 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1891 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (3)]);
		SCM res = try_string_variants ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(1) - (3)]), make_music_from_simple (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)])))))
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), LYRIC_ELEMENT, (yyvsp[(3) - (3)]));
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, (yyvsp[(3) - (3)]));
	}
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1909 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (3)]);
		SCM res = try_string_variants ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(1) - (3)]), make_music_from_simple (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)])))))
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), LYRIC_ELEMENT, (yyvsp[(3) - (3)]));
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, (yyvsp[(3) - (3)]));
	}
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1927 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (3)]);
		if (scm_is_true (scm_call_1 ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]))))
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, (yyvsp[(3) - (3)]));
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(1) - (3)]), make_music_from_simple (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)])))))
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), LYRIC_ELEMENT, (yyvsp[(3) - (3)]));
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, (yyvsp[(3) - (3)]));
	}
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1941 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (3)]);
		if (scm_is_true (scm_call_1 ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]))))
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), REAL, (yyvsp[(3) - (3)]));
		else {
			SCM d = make_duration ((yyvsp[(3) - (3)]));
			if (SCM_UNBNDP (d) || scm_is_false (scm_call_1 ((yyvsp[(1) - (3)]), d)))
				MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), REAL, (yyvsp[(3) - (3)]));
			else
				MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), DURATION_IDENTIFIER, d);
		}
	}
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1954 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (3)]);
		MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), DURATION_IDENTIFIER, (yyvsp[(3) - (3)]));
	}
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1959 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (4)]);
		SCM n = scm_difference ((yyvsp[(4) - (4)]), SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 ((yyvsp[(1) - (4)]), n)))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)]), REAL, n);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[(4) - (4)]));
			t->set_property ("digit", (yyvsp[(4) - (4)]));
			SCM m = t->unprotect ();
			if (scm_is_true (scm_call_1 ((yyvsp[(1) - (4)]), m)))
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)]), SCM_ARG, m);
			else
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)]), SCM_ARG, (yyvsp[(4) - (4)]));
		}
		
	}
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1976 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (4)]);
		SCM n = scm_difference ((yyvsp[(4) - (4)]), SCM_UNDEFINED);
		MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)]), REAL, n);
	}
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1986 "parser.yy"
    {
		(yyval) = scm_cons (loc_on_music ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
	}
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1992 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1996 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 2001 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 2006 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (4)]),
				       scm_difference ((yyvsp[(4) - (4)]), SCM_UNDEFINED),
				       (yyvsp[(2) - (4)]), (yyvsp[(1) - (4)]));
	}
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 2012 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 2017 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 2022 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 2027 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 2035 "parser.yy"
    {
		(yyval) = scm_cons (loc_on_music ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
	}
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 2044 "parser.yy"
    {
		(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)])), (yyvsp[(3) - (3)]));
	}
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 2061 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("music-function", (yyloc),
					 (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 2068 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("music-function", (yyloc),
					 (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 2076 "parser.yy"
    { (yyval) = SCM_EOL; }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 2077 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 2084 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 2085 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 2087 "parser.yy"
    {
		(yyval) = FINISH_MAKE_SYNTAX ((yyvsp[(1) - (2)]), (yyloc), (yyvsp[(2) - (2)]));
	}
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 2093 "parser.yy"
    {
                Context_mod *ctxmod = unsmob_context_mod ((yyvsp[(4) - (4)]));
                SCM mods = SCM_EOL;
                if (ctxmod)
                        mods = ctxmod->get_mods ();
		(yyval) = START_MAKE_SYNTAX ("context-specification", (yyvsp[(2) - (4)]), (yyvsp[(3) - (4)]), mods, SCM_BOOL_F);
	}
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 2100 "parser.yy"
    {
                Context_mod *ctxmod = unsmob_context_mod ((yyvsp[(4) - (4)]));
                SCM mods = SCM_EOL;
                if (ctxmod)
                        mods = ctxmod->get_mods ();
		(yyval) = START_MAKE_SYNTAX ("context-specification", (yyvsp[(2) - (4)]), (yyvsp[(3) - (4)]), mods, SCM_BOOL_T);
	}
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 2110 "parser.yy"
    {
		if ((yyvsp[(1) - (2)]) == ly_symbol2scm ("chords"))
		{
		  (yyval) = MAKE_SYNTAX ("unrelativable-music", (yyloc), (yyvsp[(2) - (2)]));
		}
		else
		{
		  (yyval) = (yyvsp[(2) - (2)]);
		}
		parser->lexer_->pop_state ();
	}
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 2121 "parser.yy"
    {
                Context_mod *ctxmod = unsmob_context_mod ((yyvsp[(2) - (3)]));
                SCM mods = SCM_EOL;
                if (ctxmod)
                        mods = ctxmod->get_mods ();
		(yyval) = MAKE_SYNTAX ("context-specification", (yyloc), (yyvsp[(1) - (3)]), SCM_EOL, mods, SCM_BOOL_T, (yyvsp[(3) - (3)]));
		if ((yyvsp[(1) - (3)]) == ly_symbol2scm ("ChordNames"))
		{
		  (yyval) = MAKE_SYNTAX ("unrelativable-music", (yyloc), (yyval));
		}
		parser->lexer_->pop_state ();
	}
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 2136 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);

		(yyval) = ly_symbol2scm ("notes");
	}
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 2143 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("drumPitchNames");
		parser->lexer_->push_note_state (nn);

		(yyval) = ly_symbol2scm ("drums");
	}
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 2149 "parser.yy"
    {
		parser->lexer_->push_figuredbass_state ();

		(yyval) = ly_symbol2scm ("figures");
	}
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 2154 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("chordmodifiers");
		parser->lexer_->chordmodifier_tab_ = alist_to_hashq (nn);
		nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_chord_state (nn);
		(yyval) = ly_symbol2scm ("chords");

	}
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 2163 "parser.yy"
    { parser->lexer_->push_lyric_state ();
		(yyval) = ly_symbol2scm ("lyrics");
	}
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 2169 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("drumPitchNames");
		parser->lexer_->push_note_state (nn);

		(yyval) = ly_symbol2scm ("DrumStaff");
	}
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 2175 "parser.yy"
    {
		parser->lexer_->push_figuredbass_state ();

		(yyval) = ly_symbol2scm ("FiguredBass");
	}
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 2180 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("chordmodifiers");
		parser->lexer_->chordmodifier_tab_ = alist_to_hashq (nn);
		nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_chord_state (nn);
		(yyval) = ly_symbol2scm ("ChordNames");
	}
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 2188 "parser.yy"
    { parser->lexer_->push_lyric_state ();
		(yyval) = ly_symbol2scm ("Lyrics");
	}
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 2194 "parser.yy"
    { parser->lexer_->push_lyric_state (); }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 2196 "parser.yy"
    {
	/* Can also use music at the expensive of two S/Rs similar to
           \repeat \alternative */
		parser->lexer_->pop_state ();

		(yyval) = scm_cons ((yyvsp[(3) - (3)]), SCM_EOL);
	}
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 2203 "parser.yy"
    {
		parser->lexer_->push_lyric_state ();
	}
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 2205 "parser.yy"
    {
		parser->lexer_->pop_state ();
		(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(1) - (4)]));
	}
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 2212 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("add-lyrics", (yyloc), (yyvsp[(1) - (2)]), scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL));
	}
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 2215 "parser.yy"
    {
		parser->lexer_->push_lyric_state ();
	}
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 2217 "parser.yy"
    {
		parser->lexer_->pop_state ();
		(yyval) = MAKE_SYNTAX ("lyric-combine", (yyloc), (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
	}
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 2224 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("context-change", (yyloc), (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
	}
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 2231 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL);
	}
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 2234 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 2240 "parser.yy"
    {
		(yyval) = scm_list_3 (ly_symbol2scm ("assign"), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 2243 "parser.yy"
    {
		(yyval) = scm_list_2 (ly_symbol2scm ("unset"), (yyvsp[(2) - (2)]));
	}
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 2246 "parser.yy"
    {
		if (scm_ilength ((yyvsp[(2) - (4)])) < 2) {
			parser->parser_error ((yylsp[(2) - (4)]), _("bad grob property path"));
			(yyval) = SCM_UNDEFINED;
		} else {
			(yyval) = scm_cons (ly_symbol2scm ("push"),
				       scm_cons2 (scm_car ((yyvsp[(2) - (4)])),
						  (yyvsp[(4) - (4)]),
						  scm_cdr ((yyvsp[(2) - (4)]))));
		}
	}
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 2257 "parser.yy"
    {
		(yyval) = scm_cons (ly_symbol2scm ("pop"), (yyvsp[(2) - (2)]));
	}
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 2287 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (3)]);
	}
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 2294 "parser.yy"
    {
		if (scm_is_null ((yyvsp[(1) - (1)]))
		    || scm_is_null (scm_cdr ((yyvsp[(1) - (1)]))))
			MYBACKUP (SCM_ARG, (yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
		else
			MYBACKUP (SYMBOL_LIST, scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL), (yylsp[(1) - (1)]));
	}
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 2307 "parser.yy"
    {
		(yyval) = scm_append_x (scm_list_2 ((yyvsp[(5) - (5)]), (yyvsp[(3) - (5)])));
	}
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 2311 "parser.yy"
    {
		(yyval) = scm_append_x (scm_list_2 ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)])));
	}
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 2317 "parser.yy"
    { (yyval) = ly_symbol2scm ("consists"); }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 2318 "parser.yy"
    { (yyval) = ly_symbol2scm ("remove"); }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 2320 "parser.yy"
    { (yyval) = ly_symbol2scm ("accepts"); }
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 2321 "parser.yy"
    { (yyval) = ly_symbol2scm ("default-child"); }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 2322 "parser.yy"
    { (yyval) = ly_symbol2scm ("denies"); }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 2324 "parser.yy"
    { (yyval) = ly_symbol2scm ("alias"); }
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 2325 "parser.yy"
    { (yyval) = ly_symbol2scm ("translator-type"); }
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 2326 "parser.yy"
    { (yyval) = ly_symbol2scm ("description"); }
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 2327 "parser.yy"
    { (yyval) = ly_symbol2scm ("context-name"); }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 2331 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 2332 "parser.yy"
    {
		(yyval) = scm_list_2 ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 2336 "parser.yy"
    {
		if (!scm_is_string ((yyvsp[(2) - (2)]))
		    && ly_symbol2scm ("consists") != (yyvsp[(1) - (2)])
		    && ly_symbol2scm ("remove") != (yyvsp[(1) - (2)]))
		{
			(yyval) = SCM_EOL;
			parser->parser_error ((yylsp[(1) - (2)]), _ ("only \\consists and \\remove take non-string argument."));
		}
		else
		{
			(yyval) = scm_list_2 ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
		}
	}
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 2354 "parser.yy"
    {
		SCM l = scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL);
		if (scm_is_pair (l)
		    && to_boolean
		    (scm_object_property (scm_car (l),
					  ly_symbol2scm ("is-grob?"))))
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		if (scm_is_null (l) || scm_is_null (scm_cdr (l))) {
			parser->parser_error ((yylsp[(1) - (1)]), _ ("bad grob property path"));
			l = SCM_UNDEFINED;
		}
		(yyval) = l;
	}
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 2372 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(1) - (1)])) && scm_is_null (scm_cddr ((yyvsp[(1) - (1)]))))
		{
			parser->parser_error ((yylsp[(1) - (1)]), _ ("bad grob property path"));
			(yyval) = SCM_UNDEFINED;
		}
	}
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 2380 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(1) - (2)]))) {
			(yyval) = scm_append_x (scm_list_2 ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)])));
			if (scm_is_null (scm_cddr ((yyval)))) {
				parser->parser_error ((yyloc), _ ("bad grob property path"));
				(yyval) = SCM_UNDEFINED;
			}
		}

	}
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 2395 "parser.yy"
    {
		SCM l = scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL);
		switch (scm_ilength (l)) {
		case 1:
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		case 2:
			break;
		default:
			parser->parser_error ((yylsp[(1) - (1)]), _ ("bad context property path"));
			l = SCM_UNDEFINED;
		}
		(yyval) = l;
	}
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 2411 "parser.yy"
    {
		if (SCM_UNBNDP ((yyvsp[(2) - (4)])))
			(yyval) = SCM_UNDEFINED;
		else {
			(yyval) = scm_list_5 (scm_car ((yyvsp[(2) - (4)])),
					 ly_symbol2scm ("OverrideProperty"),
					 scm_cadr ((yyvsp[(2) - (4)])),
					 (yyvsp[(4) - (4)]),
					 scm_cddr ((yyvsp[(2) - (4)])));
		}
	}
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 2422 "parser.yy"
    {
		(yyval) = scm_list_4 ((yyvsp[(2) - (3)]),
				 ly_symbol2scm ("RevertProperty"),
				 scm_car ((yyvsp[(3) - (3)])),
				 scm_cdr ((yyvsp[(3) - (3)])));
	}
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 2428 "parser.yy"
    {
		if (SCM_UNBNDP ((yyvsp[(2) - (4)])))
			(yyval) = SCM_UNDEFINED;
		else
			(yyval) = scm_list_4 (scm_car ((yyvsp[(2) - (4)])),
					 ly_symbol2scm ("PropertySet"),
					 scm_cadr ((yyvsp[(2) - (4)])),
					 (yyvsp[(4) - (4)]));
	}
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 2437 "parser.yy"
    {
		if (SCM_UNBNDP ((yyvsp[(2) - (2)])))
			(yyval) = SCM_UNDEFINED;
		else
			(yyval) = scm_list_3 (scm_car ((yyvsp[(2) - (2)])),
					 ly_symbol2scm ("PropertyUnset"),
					 scm_cadr ((yyvsp[(2) - (2)])));
	}
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 2464 "parser.yy"
    {
		(yyvsp[(1) - (1)]) = scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL);
		if (scm_is_null ((yyvsp[(1) - (1)]))
		    || to_boolean
		    (scm_object_property (scm_car ((yyvsp[(1) - (1)])),
					  ly_symbol2scm ("is-grob?")))) {
			(yyval) = ly_symbol2scm ("Bottom");
			parser->lexer_->push_extra_token (SCM_IDENTIFIER, (yyvsp[(1) - (1)]));
		} else {
			(yyval) = scm_car ((yyvsp[(1) - (1)]));
			parser->lexer_->push_extra_token (SCM_IDENTIFIER,
							  scm_cdr ((yyvsp[(1) - (1)])));
		}
	}
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 2481 "parser.yy"
    {
		if (SCM_UNBNDP ((yyvsp[(1) - (1)])))
			(yyval) = MAKE_SYNTAX ("void-music", (yylsp[(1) - (1)]));
		else
			(yyval) = LOWLEVEL_MAKE_SYNTAX (ly_lily_module_constant ("property-operation"), scm_cons2 (parser->self_scm (), make_input ((yyloc)), (yyvsp[(1) - (1)])));
	}
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 2490 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 2496 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 2500 "parser.yy"
    {
		if (scm_is_string ((yyvsp[(1) - (1)]))) {
			(yyval) = (yyvsp[(1) - (1)]);
		} else {
			parser->parser_error ((yylsp[(1) - (1)]), (_ ("simple string expected")));
			(yyval) = scm_string (SCM_EOL);
		}
	}
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 2511 "parser.yy"
    {
		(yyval) = scm_string_to_symbol ((yyvsp[(1) - (1)]));
	}
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 2515 "parser.yy"
    {
		// This is a bit of overkill but makes the same
		// routine responsible for all symbol interpretations.
		(yyval) = try_string_variants (ly_lily_module_constant ("symbol?"),
					  (yyvsp[(1) - (1)]));
		if (SCM_UNBNDP ((yyval)))
		{
			parser->parser_error ((yylsp[(1) - (1)]), (_ ("symbol expected")));
			// Generate a unique symbol in case it is used
			// for an assignment or similar
			(yyval) = scm_make_symbol (ly_string2scm ("undefined"));
		}
	}
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 2542 "parser.yy"
    {
		(yyval) = scm_difference ((yyvsp[(2) - (2)]), SCM_UNDEFINED);
	}
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 2550 "parser.yy"
    {
		// Let the rhythmic music iterator sort this mess out.
		if (scm_is_pair ((yyvsp[(2) - (2)]))) {
		        (yyval) = make_music_from_simple (parser, (yylsp[(1) - (2)]), (yyvsp[(1) - (2)]));
			if (unsmob_music ((yyval)))
                                unsmob_music ((yyval))->set_property ("articulations",
                                                                 scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL));
                        else
			{
                                parser->parser_error ((yylsp[(1) - (2)]), _("music expected"));
				(yyval) = MAKE_SYNTAX ("void-music", (yylsp[(1) - (2)]));
			}
		}
	}
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 2564 "parser.yy"
    {
		if (scm_is_pair ((yyvsp[(2) - (2)]))) {
			if (unsmob_pitch ((yyvsp[(1) - (2)])))
				(yyvsp[(1) - (2)]) = make_chord_elements ((yylsp[(1) - (2)]),
							  (yyvsp[(1) - (2)]),
							  parser->default_duration_.smobbed_copy (),
							  SCM_EOL);

			SCM elts = ly_append2 ((yyvsp[(1) - (2)]), scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL));

			(yyval) = MAKE_SYNTAX ("event-chord", (yylsp[(1) - (2)]), elts);
		} else if (!unsmob_pitch ((yyvsp[(1) - (2)])))
			(yyval) = MAKE_SYNTAX ("event-chord", (yylsp[(1) - (2)]), (yyvsp[(1) - (2)]));
		// A mere pitch drops through.
	}
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 2579 "parser.yy"
    {
		Input i;
		i.set_location ((yylsp[(1) - (3)]), (yylsp[(3) - (3)]));
		(yyval) = MAKE_SYNTAX ("repetition-chord", i,
				  (yyvsp[(2) - (3)]), scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL));
	}
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 2585 "parser.yy"
    {
		Input i;
		i.set_location ((yylsp[(1) - (3)]), (yylsp[(3) - (3)]));
		(yyval) = MAKE_SYNTAX ("multi-measure-rest", i, (yyvsp[(2) - (3)]),
				  scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL));
	}
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 2598 "parser.yy"
    {
		Music *m = unsmob_music ((yyvsp[(1) - (3)]));
		SCM dur = unsmob_duration ((yyvsp[(2) - (3)]))->smobbed_copy ();
		SCM es = m->get_property ("elements");
		SCM postevs = scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL);

		for (SCM s = es; scm_is_pair (s); s = scm_cdr (s))
		  unsmob_music (scm_car (s))->set_property ("duration", dur);
		es = ly_append2 (es, postevs);

		m-> set_property ("elements", es);
		m->set_spot ((yyloc));
		(yyval) = m->self_scm ();
	}
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 2616 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("event-chord", (yyloc), scm_reverse_x ((yyvsp[(2) - (3)]), SCM_EOL));
	}
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 2623 "parser.yy"
    { (yyval) = SCM_EOL; }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 2624 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(2) - (2)])))
			(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 2632 "parser.yy"
    {
		bool q = to_boolean ((yyvsp[(3) - (5)]));
		bool ex = to_boolean ((yyvsp[(2) - (5)]));
		SCM check = (yyvsp[(4) - (5)]);
		SCM post = (yyvsp[(5) - (5)]);

		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("pitch", (yyvsp[(1) - (5)]));
		if (q)
			n->set_property ("cautionary", SCM_BOOL_T);
                if (ex || q)
			n->set_property ("force-accidental", SCM_BOOL_T);

		if (scm_is_pair (post)) {
			SCM arts = scm_reverse_x (post, SCM_EOL);
			n->set_property ("articulations", arts);
		}
		if (scm_is_number (check))
		{
			int q = scm_to_int (check);
			n->set_property ("absolute-octave", scm_from_int (q-1));
		}

		(yyval) = n->unprotect ();
	}
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 2657 "parser.yy"
    {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("drum-type", (yyvsp[(1) - (2)]));

		if (scm_is_pair ((yyvsp[(2) - (2)]))) {
			SCM arts = scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL);
			n->set_property ("articulations", arts);
		}
		(yyval) = n->unprotect ();
	}
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 2668 "parser.yy"
    {
		Music *m = unsmob_music ((yyvsp[(1) - (1)]));

		while (m && m->is_mus_type ("music-wrapper-music")) {
			(yyval) = m->get_property ("element");
			m = unsmob_music ((yyval));
		}

		if (!(m && m->is_mus_type ("rhythmic-event"))) {
			parser->parser_error ((yyloc), _ ("not a rhythmic event"));
			(yyval) = SCM_UNDEFINED;
		}
	}
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 2695 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("music-function", (yyloc),
					 (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 2702 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("music-function", (yyloc),
					 (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 2709 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 2715 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 2722 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 2725 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (2)]);
		if (Music *m = unsmob_music ((yyvsp[(2) - (2)])))
		{
			if (m->is_mus_type ("post-event-wrapper"))
			{
				for (SCM p = m->get_property ("elements");
				     scm_is_pair (p);
				     p = scm_cdr (p))
				{
					(yyval) = scm_cons (scm_car (p), (yyval));
				}
			} else {
				m->set_spot ((yylsp[(2) - (2)]));
				(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyval));
			}
		}
	}
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 2746 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 2749 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
		if (!unsmob_music ((yyvsp[(2) - (2)]))->is_mus_type ("post-event")) {
			parser->parser_error ((yylsp[(2) - (2)]), _ ("post-event expected"));
			(yyval) = SCM_UNSPECIFIED;
		} else if (!SCM_UNBNDP ((yyvsp[(1) - (2)])))
		{
			unsmob_music ((yyval))->set_property ("direction", (yyvsp[(1) - (2)]));
		}
	}
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 2759 "parser.yy"
    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[(1) - (1)]), _ ("have to be in Lyric mode for lyrics"));
		(yyval) = MY_MAKE_MUSIC ("HyphenEvent", (yyloc))->unprotect ();
	}
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 2764 "parser.yy"
    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[(1) - (1)]), _ ("have to be in Lyric mode for lyrics"));
		(yyval) = MY_MAKE_MUSIC ("ExtenderEvent", (yyloc))->unprotect ();
	}
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 2769 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(1) - (2)])))
		{
			Music *m = unsmob_music ((yyvsp[(2) - (2)]));
			m->set_property ("direction", (yyvsp[(1) - (2)]));
		}
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 2777 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(1) - (2)])))
		{
			Music *m = unsmob_music ((yyvsp[(2) - (2)]));
			m->set_property ("direction", (yyvsp[(1) - (2)]));
		}
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 2786 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
		unsmob_music ((yyval))->set_property ("direction", scm_from_int (UP));
	}
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 2791 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
		unsmob_music ((yyval))->set_property ("direction", scm_from_int (DOWN));
	}
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 2799 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2805 "parser.yy"
    {
		Music *s = MY_MAKE_MUSIC ("StringNumberEvent", (yyloc));
		s->set_property ("string-number", (yyvsp[(1) - (1)]));
		(yyval) = s->unprotect ();
	}
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2814 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2817 "parser.yy"
    {
               Music *a = MY_MAKE_MUSIC ("TremoloEvent", (yyloc));
               a->set_property ("tremolo-type", (yyvsp[(1) - (1)]));
               (yyval) = a->unprotect ();
        }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2826 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2829 "parser.yy"
    {
		SCM s = parser->lexer_->lookup_identifier ("dash" + ly_scm2string ((yyvsp[(1) - (1)])));
		Music *a = MY_MAKE_MUSIC ("ArticulationEvent", (yyloc));
		if (scm_is_string (s))
			a->set_property ("articulation-type", s);
		else parser->parser_error ((yylsp[(1) - (1)]), _ ("expecting string as script definition"));
		(yyval) = a->unprotect ();
	}
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 2840 "parser.yy"
    { (yyval) = SCM_EOL; }
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 2841 "parser.yy"
    { (yyval) = (yyvsp[(2) - (2)]); }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2846 "parser.yy"
    {
                (yyval) = SCM_INUM0;
        }
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 2854 "parser.yy"
    {
		(yyval) = scm_from_int (1);
	}
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 2857 "parser.yy"
    {
		(yyval) = scm_oneplus ((yyvsp[(1) - (2)]));
	}
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 2863 "parser.yy"
    {
		(yyval) = scm_from_int (-1);
	}
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2866 "parser.yy"
    {
		(yyval) = scm_oneminus ((yyvsp[(1) - (2)]));
	}
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2872 "parser.yy"
    {
                if (!scm_is_eq (SCM_INUM0, (yyvsp[(2) - (2)])))
                {
                        Pitch p = *unsmob_pitch ((yyvsp[(1) - (2)]));
                        p = p.transposed (Pitch (scm_to_int ((yyvsp[(2) - (2)])),0,0));
                        (yyval) = p.smobbed_copy ();
                }
	}
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 2887 "parser.yy"
    {
                if (!scm_is_eq (SCM_INUM0, (yyvsp[(2) - (2)])))
                {
                        Pitch p = *unsmob_pitch ((yyvsp[(1) - (2)]));
                        p = p.transposed (Pitch (scm_to_int ((yyvsp[(2) - (2)])),0,0));
                        (yyval) = p.smobbed_copy ();
                }
	}
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 2899 "parser.yy"
    {
                if (!scm_is_eq (SCM_INUM0, (yyvsp[(2) - (2)])))
                {
                        Pitch p = *unsmob_pitch ((yyvsp[(1) - (2)]));
                        p = p.transposed (Pitch (scm_to_int ((yyvsp[(2) - (2)])),0,0));
                        (yyval) = p.smobbed_copy ();
                }
	}
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2910 "parser.yy"
    {
                if (!scm_is_eq (SCM_INUM0, (yyvsp[(2) - (2)])))
                {
                        Pitch p = *unsmob_pitch ((yyvsp[(1) - (2)]));
                        p = p.transposed (Pitch (scm_to_int ((yyvsp[(2) - (2)])),0,0));
                        (yyval) = p.smobbed_copy ();
                }
	}
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2921 "parser.yy"
    {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text", (yyvsp[(1) - (1)]));
		(yyval) = t->unprotect ();
	}
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2926 "parser.yy"
    {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text",
			make_simple_markup ((yyvsp[(1) - (1)])));
		(yyval) = t->unprotect ();
	}
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2933 "parser.yy"
    {
		Music *m = unsmob_music ((yyvsp[(1) - (1)]));
		if (m && m->is_mus_type ("post-event"))
			(yyval) = (yyvsp[(1) - (1)]);
		else if (Text_interface::is_markup ((yyvsp[(1) - (1)]))) {
			Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
			t->set_property ("text", (yyvsp[(1) - (1)]));
			(yyval) = t->unprotect ();
		} else
			parser->parser_error ((yylsp[(1) - (1)]), _ ("not an articulation"));
	}
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2947 "parser.yy"
    {
		Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yyloc));
		t->set_property ("digit", (yyvsp[(1) - (1)]));
		(yyval) = t->unprotect ();
	}
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2955 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Hat");
	}
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2958 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Plus");
	}
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2961 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Dash");
	}
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2964 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Bang");
	}
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2967 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Larger");
	}
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2970 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Dot");
	}
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2973 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Underscore");
	}
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2979 "parser.yy"
    { (yyval) = scm_from_int (DOWN); }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2980 "parser.yy"
    { (yyval) = scm_from_int (UP); }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2981 "parser.yy"
    { (yyval) = SCM_UNDEFINED; }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2985 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2991 "parser.yy"
    {
		(yyval) = SCM_UNDEFINED;
	}
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2994 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
		parser->default_duration_ = *unsmob_duration ((yyval));
	}
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 3003 "parser.yy"
    {
		if (SCM_UNBNDP ((yyval)))
			(yyval) = parser->default_duration_.smobbed_copy ();
	}
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 3010 "parser.yy"
    {
		(yyval) = make_duration ((yyvsp[(1) - (2)]), scm_to_int ((yyvsp[(2) - (2)])));
		if (SCM_UNBNDP ((yyval)))
		{
			parser->parser_error ((yylsp[(1) - (2)]), _ ("not a duration"));
			(yyval) = Duration ().smobbed_copy ();
		}
	}
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 3018 "parser.yy"
    {
		Duration *d = unsmob_duration ((yyvsp[(1) - (2)]));
		Duration k (d->duration_log (),
                            d->dot_count () + scm_to_int ((yyvsp[(2) - (2)])));
		k = k.compressed (d->factor ());
                scm_remember_upto_here_1 ((yyvsp[(1) - (2)]));
		(yyval) = k.smobbed_copy ();
	}
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 3029 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 3032 "parser.yy"
    {
		(yyval) = unsmob_duration ((yyval))->compressed (scm_to_int ((yyvsp[(3) - (3)]))).smobbed_copy ();
	}
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 3035 "parser.yy"
    {
		Rational  m (scm_to_int (scm_car ((yyvsp[(3) - (3)]))), scm_to_int (scm_cdr ((yyvsp[(3) - (3)]))));

		(yyval) = unsmob_duration ((yyval))->compressed (m).smobbed_copy ();
	}
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 3043 "parser.yy"
    {
		(yyval) = SCM_INUM0;
	}
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 3046 "parser.yy"
    {
		(yyval) = scm_oneplus ((yyvsp[(1) - (2)]));
	}
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 3052 "parser.yy"
    {
		(yyval) = SCM_INUM0;
	}
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 3055 "parser.yy"
    {
		if (SCM_UNBNDP (make_duration ((yyvsp[(2) - (2)]))))
			parser->parser_error ((yylsp[(2) - (2)]), _ ("not a duration"));
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 3063 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 3064 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 3065 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 3067 "parser.yy"
    {
		// as an integer, it needs to be non-negative, and otherwise
		// it needs to be suitable as a markup.
		if (scm_is_integer ((yyvsp[(1) - (1)]))
		    ? scm_is_true (scm_negative_p ((yyvsp[(1) - (1)])))
		    : !Text_interface::is_markup ((yyvsp[(1) - (1)])))
		{
			parser->parser_error ((yylsp[(1) - (1)]), _ ("bass number expected"));
			(yyval) = SCM_INUM0;
		}
	}
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 3081 "parser.yy"
    { (yyval) = ly_rational2scm (FLAT_ALTERATION); }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 3082 "parser.yy"
    { (yyval) = ly_rational2scm (SHARP_ALTERATION); }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 3083 "parser.yy"
    { (yyval) = scm_from_int (0); }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 3087 "parser.yy"
    {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		(yyval) = bfr->unprotect ();
	}
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 3091 "parser.yy"
    {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		(yyval) = bfr->self_scm ();

		if (scm_is_number ((yyvsp[(1) - (1)])))
			bfr->set_property ("figure", (yyvsp[(1) - (1)]));
		else if (Text_interface::is_markup ((yyvsp[(1) - (1)])))
			bfr->set_property ("text", (yyvsp[(1) - (1)]));

		bfr->unprotect ();
	}
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 3102 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (2)]);
		unsmob_music ((yyvsp[(1) - (2)]))->set_property ("bracket-stop", SCM_BOOL_T);
	}
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 3106 "parser.yy"
    {
		Music *m = unsmob_music ((yyvsp[(1) - (2)]));
		if (scm_to_double ((yyvsp[(2) - (2)]))) {
			SCM salter = m->get_property ("alteration");
			SCM alter = scm_is_number (salter) ? salter : scm_from_int (0);
			m->set_property ("alteration",
					 scm_sum (alter, (yyvsp[(2) - (2)])));
		} else {
			m->set_property ("alteration", scm_from_int (0));
		}
	}
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 3117 "parser.yy"
    {
		Music *m = unsmob_music ((yyvsp[(1) - (2)]));
		m->set_property ((yyvsp[(2) - (2)]), SCM_BOOL_T);
	}
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 3125 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("augmented");
	}
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 3128 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("no-continuation");
	}
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 3131 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("diminished");
	}
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 3134 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("augmented-slash");
	}
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 3140 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 3143 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
		unsmob_music ((yyval))->set_property ("bracket-start", SCM_BOOL_T);
	}
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 3150 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 3153 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 3159 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(2) - (3)]), SCM_EOL);
	}
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 3166 "parser.yy"
    { (yyval) = SCM_BOOL_F; }
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 3167 "parser.yy"
    { (yyval) = SCM_BOOL_T; }
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 3171 "parser.yy"
    {
		if (!parser->lexer_->is_note_state ())
			parser->parser_error ((yylsp[(1) - (6)]), _ ("have to be in Note mode for notes"));
		if (!SCM_UNBNDP ((yyvsp[(2) - (6)]))
                    || !SCM_UNBNDP ((yyvsp[(3) - (6)]))
                    || scm_is_number ((yyvsp[(4) - (6)]))
                    || !SCM_UNBNDP ((yyvsp[(5) - (6)]))
                    || scm_is_true ((yyvsp[(6) - (6)])))
		{
			Music *n = 0;
			if (scm_is_true ((yyvsp[(6) - (6)])))
				n = MY_MAKE_MUSIC ("RestEvent", (yyloc));
			else
				n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
			
			n->set_property ("pitch", (yyvsp[(1) - (6)]));
			if (SCM_UNBNDP ((yyvsp[(5) - (6)])))
				n->set_property ("duration",
						 parser->default_duration_.smobbed_copy ());
			else
				n->set_property ("duration", (yyvsp[(5) - (6)]));
			
			if (scm_is_number ((yyvsp[(4) - (6)])))
			{
				int q = scm_to_int ((yyvsp[(4) - (6)]));
				n->set_property ("absolute-octave", scm_from_int (q-1));
			}
			
			if (to_boolean ((yyvsp[(3) - (6)])))
				n->set_property ("cautionary", SCM_BOOL_T);
			if (to_boolean ((yyvsp[(2) - (6)])) || to_boolean ((yyvsp[(3) - (6)])))
				n->set_property ("force-accidental", SCM_BOOL_T);
			
			(yyval) = n->unprotect ();
		}
	}
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 3207 "parser.yy"
    {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("duration", (yyvsp[(2) - (2)]));
		n->set_property ("drum-type", (yyvsp[(1) - (2)]));

		(yyval) = n->unprotect ();
	}
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 3214 "parser.yy"
    {
		Music *ev = 0;
 		if (ly_scm2string ((yyvsp[(1) - (2)])) == "s") {
			/* Space */
			ev = MY_MAKE_MUSIC ("SkipEvent", (yyloc));
		  }
		else {
			ev = MY_MAKE_MUSIC ("RestEvent", (yyloc));

		    }
		ev->set_property ("duration", (yyvsp[(2) - (2)]));
 		(yyval) = ev->unprotect ();
	}
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 3231 "parser.yy"
    {
                if (!parser->lexer_->is_chord_state ())
                        parser->parser_error ((yylsp[(1) - (1)]), _ ("have to be in Chord mode for chords"));
                (yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 3236 "parser.yy"
    {
		for (SCM s = (yyvsp[(1) - (2)]); scm_is_pair (s); s = scm_cdr (s))
		{
			unsmob_music (scm_car (s))->set_property ("duration", (yyvsp[(2) - (2)]));
		}
		(yyval) = (yyvsp[(1) - (2)]);
	}
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 3246 "parser.yy"
    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[(1) - (1)]), _ ("markup outside of text script or \\lyricmode"));
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 3251 "parser.yy"
    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[(1) - (1)]), _ ("unrecognized string, not in text script or \\lyricmode"));
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 3260 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("lyric-event", (yyloc), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
		if (scm_is_pair ((yyvsp[(3) - (3)])))
			unsmob_music ((yyval))->set_property
				("articulations", scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL));
	}
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 3270 "parser.yy"
    {
		if (SCM_UNBNDP ((yyvsp[(2) - (2)])))
			(yyval) = (yyvsp[(1) - (2)]);
		else
			(yyval) = make_chord_elements ((yyloc), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]), SCM_EOL);
	}
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 3276 "parser.yy"
    {
		SCM its = scm_reverse_x ((yyvsp[(4) - (4)]), SCM_EOL);
		(yyval) = make_chord_elements ((yyloc), (yyvsp[(1) - (4)]), (yyvsp[(2) - (4)]), scm_cons ((yyvsp[(3) - (4)]), its));
	}
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 3283 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 3286 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyval));
	}
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 3292 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("chord-colon");
	}
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 3295 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("chord-caret");
	}
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 3298 "parser.yy"
    {
 		(yyval) = scm_list_2 (ly_symbol2scm ("chord-slash"), (yyvsp[(2) - (2)]));
	}
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 3301 "parser.yy"
    {
		(yyval) = scm_list_2 (ly_symbol2scm ("chord-bass"), (yyvsp[(2) - (2)]));
	}
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 3307 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 3310 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL);
	}
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 3313 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 3319 "parser.yy"
    { (yyval) = scm_cons ((yyvsp[(1) - (1)]), SCM_EOL); }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 3320 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(3) - (3)]), (yyval));
	}
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 3326 "parser.yy"
    {
		(yyval) = make_chord_step ((yyvsp[(1) - (1)]), 0);
        }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 3329 "parser.yy"
    {
		(yyval) = make_chord_step ((yyvsp[(1) - (2)]), SHARP_ALTERATION);
	}
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 3332 "parser.yy"
    {
		(yyval) = make_chord_step ((yyvsp[(1) - (2)]), FLAT_ALTERATION);
	}
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 3338 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 3341 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 3353 "parser.yy"
    {
		(yyval) = scm_sum ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 3356 "parser.yy"
    {
		(yyval) = scm_difference ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 3363 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 3366 "parser.yy"
    {
		(yyval) = scm_product ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 3369 "parser.yy"
    {
		(yyval) = scm_divide ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 3375 "parser.yy"
    { /* %prec UNARY_MINUS */
		(yyval) = scm_difference ((yyvsp[(2) - (2)]), SCM_UNDEFINED);
	}
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 3384 "parser.yy"
    {
		(yyval) = scm_product ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 3397 "parser.yy"
    {
		(yyval) = scm_product ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 3410 "parser.yy"
    {
		if (!scm_is_integer ((yyvsp[(1) - (1)]))
		    || scm_is_true (scm_negative_p ((yyvsp[(1) - (1)]))))
		{
			parser->parser_error ((yylsp[(1) - (1)]), _("not an unsigned integer"));
			(yyval) = SCM_INUM0;
		}
	}
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 3419 "parser.yy"
    {
		if (!scm_is_integer ((yyvsp[(1) - (1)]))
		    || scm_is_true (scm_negative_p ((yyvsp[(1) - (1)]))))
		{
			parser->parser_error ((yylsp[(1) - (1)]), _("not an unsigned integer"));
			(yyval) = SCM_INUM0;
		}
	}
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 3430 "parser.yy"
    { (yyval) = SCM_UNDEFINED; }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 3432 "parser.yy"
    {
                if (SCM_UNBNDP ((yyvsp[(1) - (2)])))
                        (yyval) = SCM_BOOL_T;
                else
                        (yyval) = scm_not ((yyvsp[(1) - (2)]));
        }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 3441 "parser.yy"
    { (yyval) = SCM_UNDEFINED; }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 3443 "parser.yy"
    {
                if (SCM_UNBNDP ((yyvsp[(1) - (2)])))
                        (yyval) = SCM_BOOL_T;
                else
                        (yyval) = scm_not ((yyvsp[(1) - (2)]));
        }
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 3453 "parser.yy"
    { parser->lexer_->push_markup_state (); }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 3454 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (3)]);
		parser->lexer_->pop_state ();
	}
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 3462 "parser.yy"
    { parser->lexer_->push_markup_state (); }
    break;

  case 510:
/* Line 1792 of yacc.c  */
#line 3463 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (3)]);
		parser->lexer_->pop_state ();
	}
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 3470 "parser.yy"
    {
		(yyval) = scm_list_2 (ly_lily_module_constant ("line-markup"),  (yyvsp[(1) - (1)]));
	}
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 3474 "parser.yy"
    {
		(yyval) = scm_car (MAKE_SYNTAX ("composed-markup-list",
					   (yylsp[(2) - (2)]), (yyvsp[(1) - (2)]), scm_list_1 ((yyvsp[(2) - (2)]))));
	}
    break;

  case 513:
/* Line 1792 of yacc.c  */
#line 3478 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 3485 "parser.yy"
    {
		if (Text_interface::is_markup ((yyvsp[(1) - (1)])))
			MYBACKUP (MARKUP_IDENTIFIER, (yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
		else if (Text_interface::is_markup_list ((yyvsp[(1) - (1)])))
			MYBACKUP (MARKUPLIST_IDENTIFIER, (yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
		else {
			parser->parser_error ((yylsp[(1) - (1)]), _ ("not a markup"));
			MYBACKUP (MARKUP_IDENTIFIER, scm_string (SCM_EOL), (yylsp[(1) - (1)]));
		}
	}
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 3499 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 3506 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 3509 "parser.yy"
    {
		(yyval) = scm_list_1 ((yyvsp[(1) - (1)]));
	}
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 3513 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 3519 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("composed-markup-list",
				  (yylsp[(2) - (2)]), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 3526 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(2) - (3)]), SCM_EOL);
	}
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 3532 "parser.yy"
    {  (yyval) = SCM_EOL; }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 3533 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 3536 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 3542 "parser.yy"
    {
	  (yyval) = scm_cons ((yyvsp[(1) - (2)]), scm_reverse_x((yyvsp[(2) - (2)]), SCM_EOL));
	}
    break;

  case 527:
/* Line 1792 of yacc.c  */
#line 3548 "parser.yy"
    {
	  (yyval) = scm_cons ((yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 528:
/* Line 1792 of yacc.c  */
#line 3551 "parser.yy"
    {
	  (yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 3554 "parser.yy"
    {
	  (yyval) = SCM_EOL;
	}
    break;

  case 530:
/* Line 1792 of yacc.c  */
#line 3560 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 531:
/* Line 1792 of yacc.c  */
#line 3561 "parser.yy"
    {
	  (yyval) = scm_cons ((yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 3567 "parser.yy"
    {
	  (yyval) = scm_cons ((yyvsp[(1) - (3)]), scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL));
	}
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 3573 "parser.yy"
    {
		(yyval) = scm_list_1 ((yyvsp[(1) - (1)]));
	}
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 3576 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 3582 "parser.yy"
    {
		(yyval) = make_simple_markup ((yyvsp[(1) - (1)]));
	}
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 3585 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);
	}
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 3588 "parser.yy"
    {
		unsmob_score ((yyvsp[(4) - (5)]))->origin ()->set_spot ((yyloc));
		(yyval) = scm_list_2 (ly_lily_module_constant ("score-markup"), (yyvsp[(4) - (5)]));
		parser->lexer_->pop_state ();
	}
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 3593 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (2)]), scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL));
	}
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 3597 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 3604 "parser.yy"
    {
		(yyval) = scm_car (MAKE_SYNTAX ("composed-markup-list",
					   (yylsp[(2) - (2)]), (yyvsp[(1) - (2)]), scm_list_1 ((yyvsp[(2) - (2)]))));
	}
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 3608 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;


/* Line 1792 of yacc.c  */
#line 7506 "./out/parser.cc"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, parser, retval, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, parser, retval, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, parser, retval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, parser, retval, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, parser, retval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3613 "parser.yy"


void
Lily_parser::set_yydebug (bool x)
{
	yydebug = x;
}

SCM
Lily_parser::do_yyparse ()
{
        SCM retval = SCM_UNDEFINED;
	yyparse (this, &retval);
        return retval;
}





/*

It is a little strange to have this function in this file, but
otherwise, we have to import music classes into the lexer.

*/
int
Lily_lexer::try_special_identifiers (SCM *destination, SCM sid)
{
	if (unsmob_book (sid)) {
		Book *book =  unsmob_book (sid)->clone ();
		*destination = book->self_scm ();
		book->unprotect ();

		return BOOK_IDENTIFIER;
	} else if (scm_is_number (sid)) {
		*destination = sid;
		return NUMBER_IDENTIFIER;
        } else if (unsmob_context_def (sid)) {
                Context_def *def= unsmob_context_def (sid)->clone ();

                *destination = def->self_scm ();
                def->unprotect ();

                return CONTEXT_DEF_IDENTIFIER;
        } else if (unsmob_context_mod (sid)) {
                *destination = unsmob_context_mod (sid)->smobbed_copy ();

                return CONTEXT_MOD_IDENTIFIER;
	} else if (Music *mus = unsmob_music (sid)) {
		mus = mus->clone ();
		*destination = mus->self_scm ();
		bool is_event = mus->is_mus_type ("post-event");
		mus->unprotect ();
		return is_event ? EVENT_IDENTIFIER : MUSIC_IDENTIFIER;
	} else if (unsmob_pitch (sid)) {
		*destination = unsmob_pitch (sid)->smobbed_copy ();
		return PITCH_IDENTIFIER;
	} else if (unsmob_duration (sid)) {
		*destination = unsmob_duration (sid)->smobbed_copy ();
		return DURATION_IDENTIFIER;
	} else if (unsmob_output_def (sid)) {
		Output_def *p = unsmob_output_def (sid);
		p = p->clone ();

		*destination = p->self_scm ();
		p->unprotect ();
		return OUTPUT_DEF_IDENTIFIER;
	} else if (unsmob_score (sid)) {
		*destination = unsmob_score (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	}

	return -1;
}

SCM
get_next_unique_context_id ()
{
	return scm_from_locale_string ("$uniqueContextId");
}


SCM
get_next_unique_lyrics_context_id ()
{
	static int new_context_count;
	char s[128];
	snprintf (s, sizeof (s)-1, "uniqueContext%d", new_context_count++);
	return scm_from_locale_string (s);
}

// check_scheme_arg checks one argument with a given predicate for use
// in an argument list and throws a syntax error if it is unusable.
// The argument is prepended to the argument list in any case.  After
// throwing a syntax error, the argument list is terminated with #f as
// its last cdr in order to mark it as uncallable while not losing
// track of its total length.
//
// There are a few special considerations: if optional argument disp
// is given (otherwise it defaults to SCM_UNDEFINED), it will be used
// instead of arg in a prospective error message.  This is useful if
// arg is not the actual argument but rather a transformation of it.
//
// If arg itself is SCM_UNDEFINED, the predicate is considered false
// and an error message using disp is produced unconditionally.

SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp)
{
	if (SCM_UNBNDP (arg))
		args = scm_cons (disp, args);
	else {
		args = scm_cons (arg, args);
		if (scm_is_true (scm_call_1 (pred, arg)))
			return args;
	}
	scm_set_cdr_x (scm_last_pair (args), SCM_EOL);
	MAKE_SYNTAX ("argument-error", loc, scm_length (args), pred,
		     SCM_UNBNDP (disp) ? arg : disp);
	scm_set_cdr_x (scm_last_pair (args), SCM_BOOL_F);
	return args;
}

SCM loc_on_music (Input loc, SCM arg)
{
	if (Music *m = unsmob_music (arg))
	{
		m = m->clone ();
		m->set_spot (loc);
		return m->unprotect ();
	}
	return arg;
}

SCM
try_string_variants (SCM pred, SCM str)
{
	// a matching predicate is always ok
	if (scm_is_true (scm_call_1 (pred, str)))
		return str;
	// a symbol may be interpreted as a list of symbols if it helps
	if (scm_is_symbol (str)) {
		str = scm_list_1 (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
		return SCM_UNDEFINED;
	}

	// If this cannot be a string representation of a symbol list,
	// we are through.

	if (!is_regular_identifier (str, true))
		return SCM_UNDEFINED;

	str = scm_string_split (str, SCM_MAKE_CHAR ('.'));
	for (SCM p = str; scm_is_pair (p); p = scm_cdr (p))
		scm_set_car_x (p, scm_string_to_symbol (scm_car (p)));

	// Let's attempt the symbol list interpretation first.

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If there is just one symbol in the list, we might interpret
	// it as a single symbol

	if (scm_is_null (scm_cdr (str)))
	{
		str = scm_car (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
	}

	return SCM_UNDEFINED;
}

bool
is_regular_identifier (SCM id, bool multiple)
{
  if (!scm_is_string (id))
	  return false;

  string str = ly_scm2string (id);

  bool middle = false;

  for (string::iterator it=str.begin(); it != str.end (); it++)
  {
	  int c = *it & 0xff;
	  if ((c >= 'a' && c <= 'z')
	      || (c >= 'A' && c <= 'Z')
	      || c > 0x7f)
		  middle = true;
	  else if (middle && (c == '-' || c == '_' || (multiple && c == '.')))
		  middle = false;
	  else
		  return false;
  }
  return middle;
}

SCM
make_music_from_simple (Lily_parser *parser, Input loc, SCM simple)
{
	if (unsmob_music (simple))
		return simple;
	if (parser->lexer_->is_note_state ()) {
		if (scm_is_symbol (simple)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("drum-type", simple);
			return n->unprotect ();
		}
		if (unsmob_pitch (simple)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("pitch", simple);
			return n->unprotect ();
		}
		return simple;
	} else if (parser->lexer_->is_lyric_state ()) {
		if (Text_interface::is_markup (simple))
			return MAKE_SYNTAX ("lyric-event", loc, simple,
					    parser->default_duration_.smobbed_copy ());
	} else if (parser->lexer_->is_chord_state ()) {
		if (unsmob_pitch (simple))
			return MAKE_SYNTAX
				("event-chord",
				 loc,
				 make_chord_elements (loc, simple,
						      parser->default_duration_.smobbed_copy (),
						      SCM_EOL));
	}
	return simple;
}

Music *
make_music_with_input (SCM name, Input where)
{
       Music *m = make_music_by_name (name);
       m->set_spot (where);
       return m;
}

SCM
make_simple_markup (SCM a)
{
	return a;
}

SCM
make_duration (SCM d, int dots)
{
	int t = scm_to_int (d);
	if (t > 0 && (t & (t-1)) == 0)
		return Duration (intlog2 (t), dots).smobbed_copy ();
	else
		return SCM_UNDEFINED;
}

SCM
make_chord_step (SCM step_scm, Rational alter)
{
        int step = scm_to_int (step_scm);

	if (step == 7)
		alter += FLAT_ALTERATION;

	while (step < 0)
		step += 7;
	Pitch m ((step -1) / 7, (step - 1) % 7, alter);
	return m.smobbed_copy ();
}


SCM
make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list)
{
	SCM chord_ctor = ly_lily_module_constant ("construct-chord-elements");
	SCM res = scm_call_3 (chord_ctor, pitch, dur, modification_list);
	for (SCM s = res; scm_is_pair (s); s = scm_cdr (s))
	{
		unsmob_music (scm_car (s))->set_spot (loc);
	}
	return res;
}

int
yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser)
{
	Lily_lexer *lex = parser->lexer_;

	lex->lexval_ = s;
	lex->lexloc_ = loc;
	lex->prepare_for_next_token ();
	return lex->yylex ();
}
